C
C File: CHARD.FOR
C Description: Chard and related routines.
C
C      Subroutine CHARD( K,K2 )
C      ENTRY ARGRD( QUESTN,ANSWER )
C      ENTRY CTZRD( KCTZ )
C      ENTRY Ugetrd( LINEIQ, LENIQ )
C      ENTRY CLlast( LENGTH )
C
C  Update Historty
C
C  27/JUL/89  A.Shirahashi, PF4 as 'resume execution'
C  16/SEP/89  A.Shirahashi, add Subroutine OPNRD
C  18/SEP/89  A.Shirahashi, @% as '%output off' and @# as '%output on'
C
C  26/SEP/89  A.Shirahashi, add CLIMEM Function
C  16/NOV/89  A.Shirahashi, add CLCURL Subroutine
C
C  10-Jun-92  A.Shirahashi, fix a bug around LOPNRD
C                           move LINRD,FLARD,FLGRD to FLGRD.FOR
C  15-Jun-92, A.Shirahashi, rename ISATTY -> CLITTY
C                           move CLHINS,CLHREC,CLHALL to CLHINS.FOR
C  16-Jun-92, A.Shirahashi, add LUNRD, rename CLINSQ to UGETRD
C                           split into 2 files: CHARD.FOR and CLGETL.FOR
C                           remove many unused variables
C  26-Jun-92, A.Shirahashi, fix a bug in UGETRD
C  11-Aug-92, A.Shirahahsi, do not tread '\' as input cancel.
C  20-Oct-92, Call CLhcmd if ! at first column
C  26-Oct-92, Call CLmacr in Argrd
C   1-Apr-94, Add Opt_AT,Opt_ECHO,Opt_EOF in CLIBLK
C             Check OPT_AT in ARGRD
C
C *********************************************************************
C
C ---------
C   CHARD   ... get one Character
C ---------
      Subroutine ChaRD( K,K2 )
C
      Implicit None
C constant
      include 'clidef.inc'
C common
      include 'unitrd.inc'
      include 'flagrd.inc'
      include 'tvdisp.inc'
      include 'clitxt.inc'
      External CLIBLK
C arg
C (Chard)
      Character *  1   K, K2
C (Argrd)
      Character * (*)  QUESTN, ANSWER
C (Ungetrd)
      Character * (*)  LINEIQ
      Integer   *  4   LENIQ
C (CLlast)
      Integer   *  4   Llast
C local
      Integer  Last, KCTZ, L
C
      Character * 256  Line
C
      Save  Line, Last
C function
      Logical  IFATN
C begin
      If( Ipnt.gt.Last ) Goto 880
C
C     ... replace a symbol
      If( Line(Ipnt:Ipnt).eq.'$' ) Then
        L = Last - Ipnt + 1
        Call CLmacS(Line(Ipnt:),L)
        Last = Ipnt + L - 1
      End If
C
      K = Line(Ipnt:Ipnt)
      Ipnt = Ipnt + 1
      K2 = Line(Ipnt:Ipnt)
C
CCC    If (IPNT.eq.2 .and. K.eq.'?' .and. (HELSET.and.4).eq.0) Then
CCC      K = ' '
CCC      Call GET_HELP
CCC    End If
C
C*      If (K.eq.BSLA) Then
C*        IFLQ = 1
C*        IPNT = 0
C*      End If
CCC   If (K.eq.'@') Goto 2
      Return
C
880   Continue
      K = CRET
      K2 = K
C
      Return
C
C ---------
C   ARGRD   ... get a new line
C ---------
       ENTRY ARGRD( QUESTN,ANSWER )
C
C BEGIN
       QUEST = QUESTN
       ANSWE = ANSWER
C      ... check If attention accepted
       If( IFATN() ) Then
         Call RSTATN()
         If( LUNPTR .gt. 0 ) Call CLSTOP()
       End If
C
C      ... check If the buffer is exausted.
       If( IPNT.ne.0 .and. IPNT.gt.LAST .and. IFCR.ne.0 ) Then
         IFLQ = 1
         IPNT = 0
       End If
C
C      ... If buffer is not empty, then return.
       If( Ipnt.ne.0 ) Then
         Return
       End If
C
100    Continue
C      ... get one Logical line
       Call CLgetL( LINE,LAST )
       IFLQ = 0
       ICOM = 0
C
C      ... check If this line is EOF
       If( LAST .lt. 0 ) Then
         Call CLIEOF()
         IPNT = 0
         LAST = 0
         IFLQ = 1
         Goto 100
       End If
C
200    Continue
       IPNT = 1
C
C      ... parse CLI command
       If( LAST.gt.0 .and. LINE(1:1).eq.'@' .and. Opt_AT.ne.0 ) Then
         Call CLICMD( LINE,LAST )
C        ... get next line
         IPNT = 0
         LAST = 0
         IFLQ = 1
         Goto 100
       Else If( last.gt.0 .and. line(1:1).eq.'!' ) Then
         Call CLhcmd( line,last )
         If( last.lt.0 ) Then
           ipnt = 0
           last = 0
           iflq = 1
           Goto 100
         Else
           Call CLputL(6,line(:last))
           Goto 200
         End If
       End If
C
CDBG   Write( 6,* ) 'ILOG,LUNIN=',ILOG,LUNIN
C@     If( IFLOG ) Call CLWLOG( LINE1(1:LAST1) )
C
C      ... Return to caller
       Return
C
C
C..... DEFINE HANDLING OF ^Z
C
       ENTRY CTZRD(KCTZ)
C
       ICTZ = KCTZ
       Return
C
C ----------
C   UGETRD   ... put string into input queue
C ----------
      ENTRY UGETRD( LINEIQ, LENIQ )
C
      Call RSTATN()
C
C     LINE(1:LENIQ) = LINEIQ(1:LENIQ)
C     LINE(LENIQ+1:) = ' '
C     LAST = LENIQ
C
C     IPNT = 1
C     IFLQ = 0
C
C     Print *, 'IPNT=',IPNT,',LAST=',LAST
C     Print *, 'LINE(1:32)=[',LINE(1:32),']'
C     LINE(LAST+1:) = ' '
C     LINE(IPNT+LENIQ:) = ' '//LINE(IPNT:)
C     LINE(IPNT:IPNT+LENIQ-1) = LINEIQ(1:LENIQ)
C     LAST = LAST + LENIQ + 1
C
      If( Ipnt.gt.0 .and. Last.ge.IPnt ) Then
        L = Leniq + 1 + Last - Ipnt + 1
        Line(Last+1:Last+L) = Lineiq(1:Leniq)//' '//Line(Ipnt:Last)
        Line(1:L) = Line(Last+1:Last+L)
        Last = L
      Else
        Line(1:Leniq) = Lineiq(1:Leniq)
        Last = Leniq
      End If
C
      Line(Last+1:) = ' '
      Ipnt = 1
      Iflq = 0
C
      Return
C
C ----------
C   CLLAST
C ----------
      ENTRY CLLAST( Llast )
C
C BEGIN
      Llast = MAX( LAST+1-IPNT,0 )
      Return
      End
C
C
      BLOCK Data CLIBLK
C
C Common
      include 'unitrd.inc'
C
      Data IRD / 5 /, IWR / 6 /, TLUN / 88 /, KLUN / 89 /
      Data LUNPTR / 0 /
      Data LUNLST / 5,81,82,83,84,85,86,87,0 /
C
      include 'flagrd.inc'
C
      Data IFLQ / 1 /, IFCR / 1 /
      Data ICOM / 0 /, ILOG / 0 /, INHLOG / 0 /
      Data IPNT / 0 /, IFF / 0 /, ICTZ / 1 /
      Data IDEBUG / .FALSE. /
      Data ICON / 0 /
      Data Opt_AT / 1 /, Opt_Echo / 1 /, Opt_EOF / 1 /
C
      include 'cliio.inc'
C
      Data IUNGET / 0 /
      Data IEOF / 0 /
C
      End
