# makefile for cli.olb

OBJS = CFARGS,CLOPEN,CHARD,-
       CLALIR,CLGETL,CLHCMD,CLMACR,-
       CLATOF,CLWORD,-
       FLGRD,IOPEN,-
       KEYRD,LENRD,LOGRD,NUMRD,OPNRD,TXTRD,-
       PRINTF,QOPEN,TVDUMB,-
       CLRDLN-DUMMY,MISCVMS,NARGET

OBJS_VMS = INTRD,MISCVMS,NARGET

CLI_LIBRARY = CLI.OLB($(OBJS) $(OBJS_VMS))
              
CLI.OLB : $(CLI_LIBRARY)
	@ write sys$output "...CLI.OLB is now up to date."

CLITEST : CLITEST.OBJ,CLI.OLB
	link clitest,cli/lib

SIMPLETEST : SIMPLETEST.OBJ,CLI.OLB
	link simpletest,cli/lib

update : 
	copy/modify/since=today/log *.for,*.f,*.inc,*.doc -
	lib:[lib.display.display45.export.cli]
	purge lib:[lib.display.display45.export.cli]
	copy/modify/since=today/log *.olb,*.doc -
	lib:[lib.display.display45.source.cli]
	purge lib:[lib.display.display45.source.cli]
	copy/modify/since=today/log *.doc [--.doc.cli]
	purge [--.doc.cli]

# end
