C
C File: INTRDL.FOR
C Description: Collection of "data input and conversion" routins
C
C Entries: Intrd,  Fltrd,  Fdprd,  Hexrd
C          IntrdL, FltrdL, FdprdL, HexrdL
C
C Target: UN*X (also portable on VMS)
C
C Note: This version is portable because it does not use NARGET.
C
      Subroutine Intrd( QUEST,VALUE )
C
      Implicit None
C
      Include 'clidef.inc'
C
C input
      Character quest*(*)
C (IntrdL)
      Integer * 4  minim, maxim
C input/output
      Integer * 4  value
C local
      Integer Narg
      Character  K*1, answer*16
      Real * 8  F
C
C..... CHANGE INTEGER
C
      Narg = 2
      Goto 1
C
      Entry IntrdL( quest,value,minim,maxim )
C
      Narg = 4
      Goto 1
C
1     Continue
C
      If( quest(1:1).eq.'?' ) VALUE = 0
      If( Narg.ge.3 ) VALUE = MAX( MINIM,VALUE )
      If( Narg.ge.4 ) VALUE = MIN( MAXIM,VALUE )
      Write ( ANSWER,* ) VALUE
3     Call ARGRD(quest,ANSWER)
      F = VALUE
      Call NUMRD(F,10,K)
      If (K.eq.BSLA) Goto 3
      VALUE = MIN(MAX(-2147483648.D0,F),2147483647.D0)
      If (Narg.ge.3) VALUE = MAX(MINIM,VALUE)
      If (Narg.ge.4) VALUE = MIN(MAXIM,VALUE)
      Return
      End
C
C
      Subroutine Fltrd(QUEST,VALUE)
C
      Implicit None
C
      Include 'clidef.inc'
C
      Character QUEST*(*), K*1, ANSWER*16
      Real*4 VALUE, MINIM, MAXIM
C local
      Integer  Narg
      Real*8 F
C
C..... CHANGE REAL*4 FLOATING
C
      Narg = 2
      Goto 1
C
      Entry FltrdL(QUEST,VALUE,MINIM,MAXIM)
C
      Narg = 4
      Goto 1

1     Continue
C
      If (QUEST(1:1).eq.'?') VALUE = 0
      If (Narg.ge.3) VALUE = MAX(MINIM,VALUE)
      If (Narg.ge.4) VALUE = MIN(MAXIM,VALUE)
      Call CLftoa( value, answer )
      If (ANSWER(12:16).eq.'0E+00') ANSWER(12:16) = ' '
3     Call ARGRD(QUEST,ANSWER)
      F = VALUE
      Call NUMRD(F,10,K)
      If (K.eq.BSLA) Goto 3
      VALUE = F
      If (Narg.ge.3) VALUE = MAX(MINIM,VALUE)
      If (Narg.ge.4) VALUE = MIN(MAXIM,VALUE)
      Return
      End
C
C

      Subroutine FDPRD( QUEST,VALUE )
C
      Implicit None 
C
      Include 'clidef.inc'
C
      Character QUEST*(*), K*1, ANSWER*16
      Real*8 VALUE, MINI, MAXI
      Real*8 F
      Integer  I3
C
C..... CHANGE REAL*8 FLOATING
C
      I3 = 2
      Goto 1
C
      Entry FDPRDL( QUEST,VALUE,MINI,MAXI )
C
      I3 = 4
      Goto 1
C
1     Continue
C
      If (QUEST(1:1).eq.'?') VALUE = 0.0D0
      If (I3.ge.3) VALUE = MAX(MINI,VALUE)
      If (I3.ge.4) VALUE = MIN(MAXI,VALUE)
C     Write (ANSWER,101) VALUE
C101  Format (1PG16.6)
C     If (ANSWER(12:16).eq.'0E+00') ANSWER(12:16) = ' '
      Call CLdtoa(value,answer)
3     Call ARGRD(QUEST,ANSWER)
      F = VALUE
      Call NUMRD(F,10,K)
      If (K.eq.BSLA) Goto 3
      VALUE = F
      If (I3.ge.3) VALUE = MAX(MINI,VALUE)
      If (I3.ge.4) VALUE = MIN(MAXI,VALUE)
C     CALL SET_NO_HELP
      Return
      End
C
C
      Subroutine HEXRD( QUEST,VALUE )
C
      Implicit None 
C
      Include 'clidef.inc'
C
      Character QUEST*(*), K*1, ANSWER*16
      Integer*4 VALUE, MINIM, MAXIM
      Real*8 F
      Integer  I3
C
C..... CHANGE INTEGER
C
      I3 = 2
      Goto 1
C
      Entry HEXRDL( QUEST,VALUE,MINIM,MAXIM )
C
      I3 = 4
      Goto 1
C
1     Continue
C
      If( QUEST(1:1).eq.'?' ) VALUE = 0
      If( I3.ge.3 ) VALUE = MAX( MINIM,VALUE )
      If( I3.ge.4 ) VALUE = MIN( MAXIM,VALUE )
      Write ( ANSWER,101 ) VALUE
101   Format (I16)
3     Call ARGRD(QUEST,ANSWER)
      F = VALUE
      Call NUMRD(F,16,K)
      If (K.eq.BSLA) Goto 3
      VALUE = MIN(MAX(-2147483648.D0,F),2147483647.D0)
      If (I3.ge.3) VALUE = MAX(MINIM,VALUE)
      If (I3.ge.4) VALUE = MIN(MAXIM,VALUE)
      Return
      End
