C
C File: Numrd.for
C Description: Convert string to double value
C
      Subroutine NUMRD(F,IRAD,K)
C
      Implicit None 
C constatnt
      include 'clidef.inc'
C input
      Integer  IRAD
C output
      Double Precision  F
      Character  K
C local
      Double Precision  RES, UNIT, BASE
      Real  SIG
      Integer  IRES, ISIG, M
      Logical CHANGD, TERMIN, EXPON, FRCTN
      Character K2, DIGIT*16
      Data DIGIT/'0123456789ABCDEF'/
C begin
      CHANGD = .FALSE.
      TERMIN = .FALSE.
      EXPON = .FALSE.
      FRCTN = .FALSE.
      SIG = 1.0
      RES = 0.0D0
      IRES = 0
      ISIG = 1
      UNIT = 1.0D0
C
   10 Continue
      Call CHARD(K,K2)
      Call STRUPC(1,K)
      If (K.eq.BSLA) Then
        Return
      Else If (K.eq.',' .or. K.eq.CRET) Then
        Goto 20
      Else If (K.ne.SPACE .or. .not.CHANGD) Then
        If (K.ne.SPACE .or. CHANGD) Then
          If (.not.TERMIN .and. K.ne.'+') Then
            M = INDEX(DIGIT(1:IRAD),K) - 1
            If (EXPON) Then
              If (K.eq.'-') Then
                ISIG = -1
                Goto 10
              Else If (M.ge.0) Then
                IRES = IRES*IRAD + M
                Goto 10
              End If
            Else If (M.ge.0) Then
              CHANGD = .TRUE.
              If (FRCTN) Then
                UNIT = UNIT/IRAD
                RES = RES + UNIT*M
              Else
                RES = RES*IRAD + M
              End If
              Goto 10
            Else If (K.eq.'-') Then
              CHANGD = .TRUE.
              SIG = -1.
              Goto 10
            Else If (K.eq.'.') Then
              CHANGD = .TRUE.
              FRCTN = .TRUE.
              Goto 10
            Else If (CHANGD .and. (K.eq.'D'.or.K.eq.'E')) Then
              EXPON = .TRUE.
              Goto 10
            Else If (.not.CHANGD) Then
              Goto 10
            End If
            TERMIN = .TRUE.
          End If
        End If
        Goto 10
      End If
   30 Continue
C
      If (K2.eq.SPACE) Then
        Call CHARD(K,K2)
        Goto 30
      End If
C
   20 BASE = IRAD
      RES = SIG*RES*BASE** (ISIG*IRES)
      If (CHANGD) F = RES
      Return
      End
