C
C File: OPNRD.FOR
C Description: Collection of input redirection routines
C 
C Public:  OPNRD, LUNRD
C
C History: 19-Jun-1992, OPNRD, LUYNRD returns status
C
C ---------
C   OPNRD
C ---------
      Integer Function Opnrd(FILE)
C
      Implicit None 
C ARG
      Character * (*)  FILE
C
C Common
      include 'flagrd.inc'
      include 'unitrd.inc'
C local
      Integer  Lfil, Ierr
C function
      Integer  Lenrd
C
C BEGIN
      If( LUNPTR .ge. MAXNST ) Then
        Call CLIERR( 2,'Command files nests too deep' )
        Opnrd = -1
        Return
      End If
C
      ISNGL = 0
      LUNPTR = LUNPTR + 1
      LFIL = LENRD( FILE )
      Call CLOPEN( FILE(1:LFIL),LUNLST(LUNPTR),'R',IERR,'.com' )
      If( IERR .ne. 0 ) Then
        If( LUNPTR .gt. 0 ) Then
          LUNPTR = LUNPTR - 1
        End If
        Opnrd = -1
      Else
        LOPNRD = .TRUE.
        Opnrd = 0
      End If
C
      Return
      End
C
C ---------
C   LUNRD
C ---------
      Integer Function Lunrd( Lin )
C
      Implicit None 
C input
      Integer  Lin
C
C Common
      include 'flagrd.inc'
      include 'unitrd.inc'
C local
      Logical  YesNo
C
C BEGIN
      If( LUNPTR .ge. MAXNST ) Then
        Call CLIERR( 2,'Command files nests too deep' )
        Lunrd = -1
        Return
      End If
C
      Inquire( Unit=Lin,Opened=YesNo )
      If( YesNo ) Then
        LUNPTR = LUNPTR + 1
        LUNLST(LUNPTR) = Lin
        LOPNRD = .TRUE.
        Lunrd = 0
      Else
        Call CLIERR( 2,'Unit not yet opened' )
        Lunrd = -1
      End If
C
      Return
      End
C
