C
      Subroutine Display45_GetComand( mode,prompt,comand,igo )
C
      Implicit None
C const
      Integer  NCOMM
      Parameter (NCOMM = 112)
C input
      Integer  mode
      Character * (*)  prompt
C output
      Character * (*)  comand
      Integer  igo
C local
      Character * 8  Comm(NCOMM)
C data
      Data Comm /         
     & 'ADD     ','ALIAS   ','AREA    ','AVX     ','AVY     ',
     & 'AXTITLE ','B       ','BANX    ','BANY    ','BINOPER ',
     & 'BLOW    ','BOOK    ','BT      ','CD      ','CHBIN   ',
     & 'CHEDGE  ','CHTIT   ','CHWIN   ','CLOSE   ','CONTOUR ',
     & 'COPY    ','CWD     ','DELETE  ','DISTRIB ','DIV     ',
     & 'DOFFT   ','DUPL    ','ECHO    ','ER      ','EXIT    ',
     & 'EXPAND  ','EXTERR  ','EXTFUN  ','FETC    ','FETC3   ',
     & 'FETMEM  ','FETX    ','FFTW    ','FIT     ','GDEL    ',
     & 'GLOBAL  ','GPL     ','GTITLE  ','H       ','HELP    ',
     & 'HIGZ    ','I       ','INCLUDE ','INTEGRAL','JOIN    ',
     & 'LEGO    ','LIN     ','LINX    ','LINY    ','LOCATE  ',
     & 'LOG     ','LOGX    ','LOGY    ','LS      ','MAMI    ',
     & 'MINUIT  ','MULT    ','N       ','NOER    ','NOFN    ',
     & 'NT      ','NTPLOT  ','OPEN    ','OPER    ','OPT     ',
     & 'P       ','PACKERR ','PACKFUN ','PDEF    ','PLOT    ',
     & 'PRINT   ','PROJ1   ','PROJ2   ','PROX    ','PROY    ',
     & 'PS      ','RANDOM  ','REBIN   ','RENUM   ','REPEAT  ',
     & 'RERROR  ','RESET   ','RESIDUAL','SCALE   ','SET     ',
     & 'SLIX    ','SLIY    ','SMOOTH  ','SORT    ','SPLINE  ',
     & 'SPLOT   ','STAT    ','STDIFF  ','STORE   ','SUB     ',
     & 'SURF    ','T       ','TABLE   ','TC      ','TITLE   ',
     & 'TS      ','TSC     ','USER    ','VALUE   ','W       ',
     & 'WINDOW  ','WKTY    '
     &  /
C
C Main Body
      Call Keyrd(mode,prompt,comand,Comm,NCOMM,igo)
C
      Return
      End
C
C
      Subroutine Display45_AmbComand( incom,outcom,igo )
C
      Implicit None
C const
      Integer  NCOMM
      Parameter (NCOMM = 112)
C input
      Character * (*)	incom
C output
      Character * (*)	outcom
      Integer  igo
C local
      Integer  L
      Character * 8  Comm(NCOMM)
C data
      Data Comm /
     & 'ADD     ','ALIAS   ','AREA    ','AVX     ','AVY     ',
     & 'AXTITLE ','B       ','BANX    ','BANY    ','BINOPER ',
     & 'BLOW    ','BOOK    ','BT      ','CD      ','CHBIN   ',
     & 'CHEDGE  ','CHTIT   ','CHWIN   ','CLOSE   ','CONTOUR ',
     & 'COPY    ','CWD     ','DELETE  ','DISTRIB ','DIV     ',
     & 'DOFFT   ','DUPL    ','ECHO    ','ER      ','EXIT    ',
     & 'EXPAND  ','EXTERR  ','EXTFUN  ','FETC    ','FETC3   ',
     & 'FETMEM  ','FETX    ','FFTW    ','FIT     ','GDEL    ',
     & 'GLOBAL  ','GPL     ','GTITLE  ','H       ','HELP    ',
     & 'HIGZ    ','I       ','INCLUDE ','INTEGRAL','JOIN    ',
     & 'LEGO    ','LIN     ','LINX    ','LINY    ','LOCATE  ',
     & 'LOG     ','LOGX    ','LOGY    ','LS      ','MAMI    ',
     & 'MINUIT  ','MULT    ','N       ','NOER    ','NOFN    ',
     & 'NT      ','NTPLOT  ','OPEN    ','OPER    ','OPT     ',
     & 'P       ','PACKERR ','PACKFUN ','PDEF    ','PLOT    ',
     & 'PRINT   ','PROJ1   ','PROJ2   ','PROX    ','PROY    ',
     & 'PS      ','RANDOM  ','REBIN   ','RENUM   ','REPEAT  ',
     & 'RERROR  ','RESET   ','RESIDUAL','SCALE   ','SET     ',
     & 'SLIX    ','SLIY    ','SMOOTH  ','SORT    ','SPLINE  ',
     & 'SPLOT   ','STAT    ','STDIFF  ','STORE   ','SUB     ',
     & 'SURF    ','T       ','TABLE   ','TC      ','TITLE   ',
     & 'TS      ','TSC     ','USER    ','VALUE   ','W       ',
     & 'WINDOW  ','WKTY    '
     &  /
C begin
	L = Min(Len(incom),Len(outcom))
	outcom = ' '
	outcom(:L) = incom(:L)
	Call Ambrd( Comm,NCOMM,outcom,igo )
C
	Return
	End
C
      Subroutine Display45_DoComand( comand, error )
C
      Implicit None
C input
      Character * (*)  comand
C output
      Integer  error
C local
      Integer MAXLEN
      Parameter (MAXLEN=8)
      Character * 8  cmd
      Integer  id, Lcmd
      Integer  option, nx, ny
C function
      Integer  Lenrd
C data
      Data nx,ny /1,1/
C begin
      If( Len(comand).ge.MAXLEN ) Then
        cmd = comand(:MAXLEN)
      Else
        cmd = comand
      End If
      Call Strupc(MAXLEN,cmd)
      Lcmd = Lenrd(cmd)
C
      error = 0
C
      If (Cmd.eq.'ADD     ') Then
        Call Hlarith('+',error)
      Else If (Cmd.eq.'ALIAS   ') Then
        Call HLalias(error)
      Else If (Cmd.eq.'AREA    ') Then
        Call HLarea(error)
      Else If (Cmd.eq.'AVX     ') Then
        Call HLavx(error)
      Else If (Cmd.eq.'AVY     ') Then
        Call HLavy(error)
      Else If (Cmd.eq.'AXTITLE ') Then
        Call HLaxtitl(error)
      Else If (Cmd.eq.'B       ') Then
        Call HLback(error)
      Else If (Cmd.eq.'BANX    ') Then
        Call Hlbanx(error)
      Else If (Cmd.eq.'BANY    ') Then
        Call Hlbany(error)
      Else If (Cmd.eq.'BINOPER ') Then
        Call HLbinoper(error)
      Else If (Cmd.eq.'BLOW    ') Then
        Call HLblow(error)
      Else If (Cmd.eq.'BOOK    ') Then
        Call HL_book(id,error)
      Else If (Cmd.eq.'BT      ') Then
        Call HLbt(error)
      Else If (Cmd.eq.'CD      ') Then
        Call HLcdir(error)
      Else If (Cmd.eq.'CHBIN   ') Then
        Call HLchbn(error)
      Else If (Cmd.eq.'CHEDGE  ') Then
        Call HLchedge(error)
      Else If (Cmd.eq.'CHTIT   ') Then
        Call HLchtit(error)
      Else If (Cmd.eq.'CHWIN   ') Then
        Call HLchwin(error)
      Else If (Cmd.eq.'CLOSE   ') Then
        Call HLclose(error)
      Else If (Cmd.eq.'CONTOUR ') Then
        Call HLcntr(error)
      Else If (Cmd.eq.'COPY    ') Then
        Call HLcopy(error)
      Else If (Cmd.eq.'CWD     ') Then
        Call HLcwd(error)
      Else If (Cmd.eq.'DELETE  ') Then
        Call HLdel(error)      
      Else If (Cmd.eq.'DISTRIB ') Then
        Call HLdist(error)
      Else If (Cmd.eq.'DIV     ') Then
        Call Hlarith('/',error)
      Else If (Cmd.eq.'DOFFT   ') Then
        Call HLdofft(error)      
      Else If (Cmd.eq.'DUPL    ') Then
        Call HLdupl(error)
      Else If (Cmd.eq.'ECHO    ') Then
        Call HLecho(error)
      Else If (Cmd.eq.'ER      ') Then
        Call HLerro(error)
      Else If (Cmd.eq.'EXPAND  ') Then
        Call HLexp(error)
      Else If (Cmd.eq.'EXTERR  ') Then
        Call HLexte(error)
      Else If (Cmd.eq.'EXTFUN  ') Then
        Call HLextfun(error)
      Else If (Cmd.eq.'FETC    ') Then
        Call HLfetc(option, error)
      Else If (Cmd.eq.'FETC3   ') Then
        Call HLfetc3(option, error)
      Else If (Cmd.eq.'FETMEM  ') Then
        Call HLfetm(error)
      Else If (Cmd.eq.'FETX    ') Then
        Call HLfetx(option, error)
      Else If (Cmd.eq.'FFTW    ') Then
        Call HLfftw(error)
      Else If (Cmd.eq.'FIT     ') Then
        Call HLfit(error)
      Else If (Cmd.eq.'GDEL    ') Then
        Call HLgdel(error)
      Else If (Cmd.eq.'GPL     ') Then
        Call HLgpl(error)
      Else If (Cmd.eq.'GTITLE  ') Then
        Call HLgtit(error)
      Else If (Cmd.eq.'H       ') Then
        Call HLmove(error)
      Else If (Cmd.eq.'HELP    ') Then
        Call HLhelp('DISPLAY',error)
      Else If (Cmd.eq.'HIGZ    ') Then
        Call HLhigz(error)
      Else If (Cmd.eq.'I       ') Then
        Call HLindx(error)
      Else If (Cmd.eq.'INCLUDE ') Then
        Call HLinclude(error)
      Else If (Cmd.eq.'INTEGRAL') Then
        Call HLinteg(error)
      Else If (Cmd.eq.'JOIN    ') Then
        Call HLjoin(error)
      Else If (Cmd.eq.'LEGO    ') Then
        Call HLlego(error)
      Else If (Cmd.eq.'LIN     ') Then
        Call DIS45_setopt(0,'LINY') 
      Else If (Cmd.eq.'LINX    ') Then
        Call DIS45_setopt(0,'LINX') 
      Else If (Cmd.eq.'LINY    ') Then
        Call DIS45_setopt(0,'LINY') 
      Else If (Cmd.eq.'LOCATE  ') Then
        Call HLlocate(error)
      Else If (Cmd.eq.'LOG     ') Then
        Call DIS45_setopt(0,'LOGY') 
      Else If (Cmd.eq.'LOGX    ') Then
        Call DIS45_setopt(0,'LOGX')
      Else If (Cmd.eq.'LOGY    ') Then
        Call DIS45_setopt(0,'LOGY')
      Else If (Cmd.eq.'LS      ') Then
        Call HLldir(error)
      Else If (Cmd.eq.'MAMI    ') Then
        Call HLmami(error)     
      Else If (Cmd.eq.'MULT    ') Then
        Call HLarith('*',error)
      Else If (Cmd.eq.'N       ') Then
        Call HLnext(error)
      Else If (Cmd.eq.'NOER    ') Then
        Call HLnoer(error)   
      Else If (Cmd.eq.'NOFN    ') Then
        Call HLpfun(0,error)
      Else If (Cmd.eq.'NT      ') Then
        Call HLnt(error)
      Else If (Cmd.eq.'NTPLOT  ') Then
        Call HLntplot(error)
      Else If (Cmd.eq.'OPEN    ') Then
        Call HLopen(error)
      Else If (Cmd.eq.'OPER    ') Then
        Call HLoper(error)
      Else If (Cmd.eq.'OPT     ') Then
        Call Hlopt(error)
      Else If (Cmd.eq.'P       ') Then
        Call HLplotP(error)
      Else If (Cmd.eq.'PACKERR ') Then
        Call HLpake(error)
      Else If (Cmd.eq.'PACKFUN ') Then
        Call HLpackfun (error)
      Else If (Cmd.eq.'PDEF    ') Then
        Call Hlpdef(error)
      Else If (Cmd.eq.'PLOT    ') Then
        Call HLmark(error)
      Else If (Cmd.eq.'PRINT   ') Then
        Call HLprint(error)
      Else If (Cmd.eq.'PROJ1   ') Then
        Call HLproj1(error)
      Else If (Cmd.eq.'PROJ2   ') Then
        Call HLproj2(error)
      Else If (Cmd.eq.'PROX    ') Then
        Call HLprox(error)
      Else If (Cmd.eq.'PROY    ') Then
        Call HLproy(error)   
      Else If (Cmd.eq.'PS      ') Then
        Call HLdevi(error)
      Else If (Cmd.eq.'RANDOM  ') Then
        Call HLrandom(error)
      Else If (Cmd.eq.'REBIN   ') Then
        Call HLrebin(error)
      Else If (Cmd.eq.'RENUM   ') Then
        Call HLrenum(error)
      Else If (Cmd.eq.'RERROR  ') Then
        Call HLrerro(error)
      Else If (Cmd.eq.'RESET   ') Then
        Call HLreset(error)
      Else If (Cmd.eq.'RESIDUAL') Then
        Call HLresi(error)
      Else If (Cmd.eq.'SCALE   ') Then
        Call HLscales(error)
      Else If (Cmd.eq.'SET     ') Then
        Call Hlset(error)      
      Else If (Cmd.eq.'SLIX    ') Then
        Call HLslix(error)
      Else If (Cmd.eq.'SLIY    ') Then
        Call HLsliy(error)
      Else If (Cmd.eq.'SMOOTH  ') Then
        Call HLsmooth(error)
      Else If (Cmd.eq.'SORT    ') Then
        Call HLsort(error)
      Else If (Cmd.eq.'SPLINE  ') Then
        Call HLspline(error)
      Else If (Cmd.eq.'SPLOT   ') Then
        Call HLsplot(error)
      Else If (Cmd.eq.'STAT    ') Then
        Call HLstat(error)
      Else If (Cmd.eq.'STDIFF  ') Then
        Call Hlstdiff(error)
      Else If (Cmd.eq.'STORE   ') Then
        Call HLstore(error)
      Else If (Cmd.eq.'SUB     ') Then
        Call HLarith('-',error)
      Else If (Cmd.eq.'SURF    ') Then
        Call HLsurf(error)
      Else If (Cmd.eq.'T       ') Then
        Call HLplot(error)
      Else If (Cmd.eq.'TABLE   ') Then
        Call HLtable(error)
      Else If (Cmd.eq.'TC      ') Then
        Call HLtc(error)
      Else If (Cmd.eq.'TITLE   ') Then
        Call HLtitle(error)
      Else If (Cmd.eq.'TS      ') Then
        Call HLts(error)
      Else If (Cmd.eq.'TSC     ') Then
        Call HLtsc(error)
      Else If (Cmd.eq.'USER    ') Then
        Call HLuser(error)
      Else If (Cmd.eq.'VALUE   ') Then
        Call HLvals(error)
      Else If (Cmd.eq.'W       ') Then
        Call HLw(error)
      Else If (Cmd.eq.'WINDOW  ') Then
        Call HLwindow(error)
      Else If (Cmd.eq.'WKTY    ') Then
        Call HLwkty
      Else 
C       ... unkonwn command
        error = 10
      End If
C      
      Return
      End
C
