       SUBROUTINE DIS45_MIN_askfreeparam(nparam)
C----------------------------------------------------------------------
C-
C-   Purpose and Methods : Ask Free Param
C-
C-
C-   Created  18-MAY-1992   T.Takahashi
C-
C----------------------------------------------------------------------
      IMPLICIT NONE
C----------------------------------------------------------------------
c
c output:
      Integer nparam
c
      Character*10 chnam
      Real*8 stval,step,bnd1,bnd2
      Integer IErflag
      Integer number_of_parameters 
      Integer i
c
c COM dialogue
      Integer MAXPARAM
      Parameter (MAXPARAM=50)

      Real    val (MAXPARAM)
      Real    err (MAXPARAM)
      Real    low_limit (MAXPARAM), up_limit (MAXPARAM)
      Character*32 help(MAXPARAM)
      Character*32 name(MAXPARAM)
C begin
      Call DIS45_MIN_get_nparam(number_of_parameters)

      If (number_of_parameters.eq.0) then
        Write(*,*) 'Parameters not yet defined'
        Return
      else if (number_of_parameters.gt.MAXPARAM) then
        Write(*,*) 'WARNING: Number of params exceed MAXPARAM'
      Endif
c
c set value
c      
      nparam=0
      DO i=1,number_of_parameters
        Call MNPOUT(i,chnam,stval,step,bnd1,bnd2,ierflag)
        If (step.gt.0) then
          nparam = nparam+1
        Endif
      End do

      Return
      END
