C----------------------------------------------------------------------
C-
C-   Purpose and Methods : 
C-   Created  18-MAY-1992   T.Takahashi
C
C    History: 2-Mar-1992 A.Shirahashi
C             Move 'call to mninit' to dis45_min_midata.f
C             call init_com_talk here instead of dis45_min_fcn.f
C             3-Mar-1992 A.Shirahashi
C             call MNinit here only for first time
C             5-Mar-1992 A.Shirahashi
C             call init_com_talk after call to dis45_min_midata
C             21-Jun-1993 K.Matsuzaki
C             subroutine DIS45_MIN_END
C             19-Nov-1993 A.S. MININIT=command
C             20-Nov-1993 A.S. MININIT=@file
C-
C----------------------------------------------------------------------
      Subroutine Dis45_Min_Init(minfile,error_flag)
C
      Implicit None
C
C input/output
      Character*(*) minfile
C output
      Integer error_flag
C local
      Real * 8  Arglist(10)
      Integer  Ierrflag
      Character * 80  comand
      Integer  Lcom
C function
      External DIS45_MIN_FCN
C data
      Logical first_time
      Save    first_time
      Data    first_time / .TRUE. /
C begin
C     ... initialize MINUIT if first time
      If( first_time ) Then
        first_time = .FALSE.
        Call MNinit(5,6,7)
      End If
C
C     ... initialize entry point for function
      Call DIS45_MIN_FCN_INIT(error_flag)
      If( error_flag.gt.0 ) Return
C
C     ... initialize fitting parameters
      Call DIS45_MIN_MIDATA(minfile,error_flag)
      If( error_flag.gt.0 ) Return
C
C     ... initialize COM
      Call Init_Com_Talk( 'MIN' )
C
C     ... initial calls to FCN
      arglist(1)=1 ! iflag=1
      Call MNEXCM(DIS45_MIN_FCN, 'CALL FCN',arglist,1,IERRFLAG)
      arglist(1)=4 ! iflag=4
      Call MNEXCM(DIS45_MIN_FCN, 'CALL FCN',arglist,1,IERRFLAG)
C
C     ... if MININIT defined, then execute the command
      Call CLgetv( 'MININIT',comand,Lcom )
C
      If( Lcom.gt.0 ) Then
        If( comand(1:1).eq.'@' ) Then
          Call Opnrd( comand(2:Lcom) )
        Else
          Call Ugetrd( comand,Lcom )
        End If
      End If
C
      Return
      End

      Subroutine DIS45_MIN_END
      Call DIS45_MIN_FCN_END(error_flag)
      Return
      End
