       SUBROUTINE DIS45_MIN_REL(DIS45_MIN_FCN,error_flag)
C----------------------------------------------------------------------
C-
C-   Purpose and Methods : Fix Parameter
C-
C-
C-   Created  18-MAY-1992   T.Takahashi
C-
C----------------------------------------------------------------------

      IMPLICIT NONE
c
c input:
      External DIS45_MIN_FCN
c output:
      Integer error_flag
C----------------------------------------------------------------------
      Character*10 chnam
      Real*8 stval,step,bnd1,bnd2
      Integer IErflag
      Integer number_of_parameters 
      Integer i
      Real*8 Arglist(10)
      Integer IERRFLAG
c
c COM dialogue
      Integer MAXPARAM
      Parameter (MAXPARAM=32) ! must be 32, COM restriction
      Real    val (MAXPARAM)
C     Real    err (MAXPARAM)
C     Real    low_limit (MAXPARAM), up_limit (MAXPARAM)
      Character*32 help(MAXPARAM)
      Character*32 name(MAXPARAM)
      Integer nreply /0/
      Integer lanswer(0:MAXPARAM)

      Call DIS45_MIN_get_nparam(number_of_parameters)

      If (number_of_parameters.eq.0) then
        Write(*,*) 'Parameters not yet defined'
        Return
      else if (number_of_parameters.gt.MAXPARAM) then
        Write(*,*) 'WARNING: Number of params exceed MAXPARAM'
        number_of_parameters=MAXPARAM
      Endif
c
c set value
c      
      DO i=1,number_of_parameters
        Call MNPOUT(i,chnam,stval,step,bnd1,bnd2,ierflag)
        name(i) = chnam
        help(i) = chnam
        val(i)  = Real(stval)
      End do
      Call INQUIRE('FIX Param',number_of_parameters,name,help,
     &  nreply, lanswer)
      Do i=1,lanswer(0)
        arglist(1)=lanswer(i)
        Call MNEXCM(DIS45_MIN_FCN, 'RELEASE',arglist,1,IERRFLAG)
      End do
      Return
      END
