C
C Subroutine to calculate theory or model
C 
C
      Subroutine min_funct(x,xwidth,par,ichoice,all,bak,sig)
C----------------------------------------------------------------------
C-
C-   Purpose and Methods : Function to be used in DISPLAY-MINUIT
C-
C-   Inputs  : 
C-   Outputs : 
C-   Controls: 
C-
C-   Created  24-JAN-1991   T.Takahashi
C-
C----------------------------------------------------------------------
      Implicit None
!
!
! input:
      Real*8       x
      Real*8       xwidth             ! Bin width
      Real*8       par(*)             ! Par(2) =  # of Gaussian to fit
      Integer      ichoice
C
C output:
      Real*8       all
      Real*8       bak
      Real*8       sig
C
C local:
C
      all = 0.
      bak = 0.
      sig = 0.
C
      If ( par(3) .ne. 0.0 ) then
        all = par(1) * Exp ( - ( x - par(2) ) ** 2 / par(3)**2 )
      Else
        all = 0.0
      End If
c
      sig = all
      bak = 0.0
c
      Return
      End
