C
C File: HLCHEDGE.FOR
C History: 
C
C    22-JUN-1993 K.Matuzaki
C
        Subroutine HLchedge(error)
C
        Implicit None
C common
	Include 'pawc.inc'
C output
	Integer error
C local:
      Integer  here, id, dim, idnew
      Integer  idbuf, loc
      Integer  nx, ny
      Integer  i
      Real  xmin, xmax, ymin, ymax
      Real  xmin1, xmax1, ymin1, ymax1
      Real  coef,ent
      Character * 80  title
C function
      Real  HIE
      Integer  DIS45_needhist, DIS45_makehist, DIS45_malloc
      Integer  DIS45_hasbar
      Integer  DIS45_hgetopt
C begin
C     require 1 dim or 2 dim histogram
      If (DIS45_needhist(0,error).le.0) Return
      Call DIS45_thishist(here, id, dim)
C
      If (dim.eq.1) Then 
        Call DIS45_hinfo1(id,title,nx,xmin,xmax)
        If( DIS45_malloc( nx*2,idbuf,loc,error ).le.0 ) Return
        xmin1 = xmin
        xmax1 = xmax
        Call Fltrd('XMIN', xmin1)
        Call Fltrd('XMAX', xmax1)
        If( DIS45_makehist( id,1,idnew,error ).le.0 ) Return
        If( DIS45_hgetopt(id,'NEQB').eq.0 ) Then
          Call Hbook1( idnew,'CHEDGE '//title,nx,xmin1,xmax1,0.0 )
        Else 
          coef = (xmax1-xmin1)/(xmax-xmin)
          Call DIS45_getxbins( id,1,nx,Rmem(loc) )
          Do i=1,nx+1
            Rmem(loc+i-1) = coef * (Rmem(loc+i-1) - xmin) + xmin1
          Enddo
          Call HbookB( idnew,'CHEDGE '//title,nx,Rmem(loc),0.0 )
        End If
        Call DIS45_locate( idbuf,loc ) 
        Call Hunpak(id,Rmem(loc),'HIST',1)
        Do i=1,nx
          Rmem(loc+nx+i-1) = HIE(id,i,)
        Enddo
        Call Hpak( idnew,Rmem(loc) )
        If( DIS45_hasbar(id).ne.0 ) Then
          Call Hpake( idnew,Rmem(loc+nx) )
        End If          
      Else If(dim.eq.2) Then
        Call DIS45_hinfo2(id,title,nx,xmin,xmax,ny,ymin,ymax)
        If( DIS45_malloc( nx*ny,idbuf,loc,error ).le.0 ) Return
        xmin1 = xmin
        xmax1 = xmax
        ymin1 = ymin
        ymax1 = ymax
        Call Fltrd('XMIN', xmin1)
        Call Fltrd('XMAX', xmax1)
        Call Fltrd('YMIN', ymin1)
        Call Fltrd('YMAX', ymax1)
        If( DIS45_makehist( id,2,idnew,error ).le.0 ) Return
        Call Hbook2(idnew,'CHEDGE '//title,nx,xmin1,xmax1,
     &                                     ny,ymin1,ymax1,0.0)    
        Call DIS45_locate( idbuf,loc ) 
        Call Hunpak(id,Rmem(loc),'HIST',1)
        Call Hpak( idnew,Hmem(loc) )
      End If
C
      Call Hnoent(id,ent) 
      Call DIS45_setentry(idnew,ent)
      Call DIS45_free( idbuf )
      Return
      End
