C
C File: HLdel.for
C Description: delete histogram(s)
C Author: A.Shirahashi
C Date: 25-Jun-1992, recovered from scratch
C
C History: 15-Jul-1992, use DIS45_numhist instead of DIS45_needhist
C
C Public  HLdel, HLgdel
C
      Subroutine HLdel(error)
C 
      Implicit None 
C output
      Integer  error
C local
      Integer  here, id, dim
C function
      Integer  DIS45_needhist
C begin
      If( DIS45_needhist(0,error).le.0 ) Return
      Call DIS45_thishist(here,id,dim)
      Call DIS45_hdelete(id)
      Return
      End
C
C     
      Subroutine HLgdel(error)
C
      Implicit None 
C output
      Integer  error
C local
      Integer  here, id, dim
      Integer  first, last
      Integer  i, j
C function
      Integer  DIS45_numhist, DIS45_lookup
C begin
      If( DIS45_numhist(error).le.0 ) Return
      Call DIS45_thishist(here,id,dim)
C
      first = id
      Call Intrd('first ID (0:all):',first)
      If( first.eq.0 ) Then
        Call DIS45_delhist(0)
        Call Hdelet(0)
        Return
      End If
C
      last = first
      Call Intrd('last ID (0:cancel):',last) 
C
      If( last.gt.0 ) Then
        Do i = first, last
          j = DIS45_lookup(i)
          If( j.gt.0 ) Then
            Call DIS45_delhist(j)
            Call Hdelet(i)
          End If
        End Do
      End If
C        
      Return
      End
C
C
