      SUBROUTINE HLINDX(error)
C----------------------------------------------------------------------
C-
C-   Purpose and Methods : List Histograms inside Display Buffer
C-
C-   Created   5-MAR-1992   T.Takahashi
C-
C-   History: 26-Jun-1992, A.Shirahashi, DIS45_numhist
C-            18-Aug-1992, A.Shirahashi, DIS45_hinfo0, one_line
C-
C----------------------------------------------------------------------
      IMPLICIT NONE
c output:
      Integer error
c
c const:
      Integer NTLI 
      Parameter (NTLI=20)
c local:
      Character*80 title
      Integer nh, here, id, dim
C     Integer nx, ny
C     Real    xmin, xmax, ymin, ymax
C     Integer nwidth, location
      Integer i, Ltit
      Character CR
c function:
      Integer DIS45_numhist, DIS45_info_i, Lenrd
C begin
      nh = DIS45_numhist(error)
      If (nh.le.0) Return
C
      Call DIS45_thishist(here,id,dim)

      Do i=1, nh
      	id = DIS45_info_i(i)
C
C       Call Hgive(id, title, nx, xmin, xmax, 
C    &                        ny, ymin, ymax,
C    &                        nwidth, location)
C       If (ny.eq.0) then
C         dim=1
C       else
C         dim=2
C       endif
C
        Call DIS45_hinfo0( id,title,dim )
        Ltit = Lenrd(title)
C
        If (i.eq.here) Then
          Write(*,1300) ' ->',i, id, dim, title(:Ltit)
        Else
          Write(*,1300) '   ',i, id, dim, title(:Ltit)
        Endif
 1300   Format(A,I6,I6,I2,2X,A) 
	If (mod(i,NTLI).eq.0) then
	  Call Linrd(1,1)
	  Call Txtrd('?Type return to continue',Cr)
          If (Cr.Ne.' ') Goto 999    ! Exit LOOP
        Endif
      Enddo
C----------------------------------------------------------------------
  999 RETURN
      END
