C
C File: HLrebin.FOR
C Date: 1-Sep-1992
C Author: A.Shirahashi
C
C History: 7-Sep-1993, Use ERRO flag instead of PERR flag
C          9-Oct-1993, Use BARX flag instaed of ERRO flag
C
        Subroutine HLrebin(error)
C
C change bin size
C
        Implicit None
C common:
	Include 'pawc.inc'
C
C output:
	Integer error
C
C function:
        Integer  DIS45_needhist, DIS45_makehist, DIS45_malloc
        Integer  DIS45_hgetopt, DIS45_getlimit1
C
C local:
	Integer  here, id, dim, idnew
	Integer  idbuf, loc
	Integer  nx, mx, cx
        Integer  fact, ixl, ixh, nl, nm, nh
        Integer  I, J
	Real  xmin, xmax
	Character * 80  title
C
C begin
        If (DIS45_needhist(1,error).le.0) Return
	Call DIS45_thishist(here, id, dim)
C
        Call DIS45_hinfo1(id,title,nx,xmin,xmax)
        fact = 2
        Call IntrdL('bin size factor',fact,2,nx)
        If( DIS45_getlimit1(id,nm,ixl,ixh,error).le.0 ) Return
C
        cx = nm/fact
        ixh = ixl + cx * fact -1
        nl = ixl - 1
C       nm = ixh - ixl + 1
        nh = nx - ixh
        mx = nl + cx + nh
C
        If( DIS45_makehist( id,1,idnew,error ).le.0 ) Return
        If( DIS45_malloc( nx*2,idbuf,loc,error ).le.0 ) Return
C
        Call DIS45_getxbins( id,1,nx,Rmem(loc) )
        J = ixl+fact
        Do I = ixl+1, ixl+cx-1
          Rmem(loc+I-1) = Rmem(loc+J-1)
          J = J + fact
        End Do
        J = ixh+1
        Do I = ixl+cx, mx+1
          Rmem(loc+I-1) = Rmem(loc+J-1)
          J = J + 1
        End Do
C
        Call HbookB( idnew,'REBIN '//title,mx,Rmem(loc),0.0 )
        Call DIS45_locate( idbuf,loc ) ! for safety
        Call DIS45_hrebin1( id,nl,1,nl,Rmem(loc),Rmem(loc+nx),
     &                      error )
        Call DIS45_hrebin1( id,cx,ixl,ixh,
     &                      Rmem(loc+nl),Rmem(loc+nx+nl),error)
        Call DIS45_hrebin1( id,nh,ixh+1,nx,
     &                      Rmem(loc+nl+cx),Rmem(loc+nx+nl+cx),error)
        Call Hpak( idnew,Rmem(loc) )
        If( DIS45_hgetopt(id,'BARX').ne.0 ) Then
          Call Hpake( idnew,Hmem(loc+nx) )
        End If          
        Call DIS45_free( idbuf )
C
	Return
	End
