C
C File: HLrenum.for
C Entry: HLrenum
C Description: Renumber histogram ID
C Author: A.Shirahashi
C Date: 6-May-1992
C 
C History: 18-Sep-1993, for N-tuple
C
        Subroutine HLrenum(error)
	Implicit None
C common
	Include 'display.inc'
C output
        Integer error
C local
        Integer  MAXSTACK
        Parameter( MAXSTACK = 20 )
        Integer  stack(MAXSTACK), pntr
        Character * 80  title
        Integer i, j, id1, id2, dim
        Integer  idstart /10/, idstep /10/
        Save idstart, idstep
C Function
        Logical  Hexist
C begin
        Call Intrd( 'start ID', idstart )
        Call Intrd( 'step', idstep )
C
        pntr = 0
        i = 1
100     Continue
        If( i .gt. Nh ) Return
        id1 = Iv(i)
        id2 = idstart + (i - 1) * idstep
        If( id1 .EQ. id2 ) Then
          i = i + 1
          Goto 100
        End If
        If( .not. Hexist( id2 ) ) Then
          Call DIS45_hinfo0(id1,title,dim)
          If( dim.eq.1 .or. dim.eq.2 ) Then
            Call Hcopy( id1,id2,title )
          Else If( dim.eq.3 ) Then
            Call DIS45_CopyNT( id1,id2,title )
          Else
            Write(*,*) 'HLrenum: unknown dim = ', dim
            Return
          End If
          Call Hdelet( id1 )
          Iv(i) = id2
          If( pntr .EQ. 0 ) Then
            i = i + 1
          Else
            i = stack( pntr )
            pntr = pntr - 1
          End If
          Goto 100
        Else
          pntr = pntr + 1
          If( pntr .gt. MAXSTACK ) Then
            Print *, 'HLrenum: stack overflow'
            Return
          End If
          stack( pntr ) = i
          Do j = 1, Nh
            If( Iv(j) .eq. id2 ) Then
              i = j
              Goto 100
            End If
          End Do
          Print *, 'HLrenum: can''t happen.'
          Return
        End If
C
        End
