C
C File: HLrerro.for
C Description: 
C     This is a routine to create a new histogram from a 1-dim.
C     histogram with statistical errors explicitly booked.
C Author: T.Takahashi
C Date: ?
C History: 20-Jul-1992, modified by A.Shirahashi for DISPLAY45
C
      Subroutine Hlrerro(error)
C
      Implicit None 
C common
      Include 'pawc.inc'
C output
      Integer  error
C local
      Integer  here, id, dim, idnew
      Integer  nx, idbuf, loc, j
      Real  xmin, xmax
      Character * 80  title
C function
      Integer  DIS45_needhist, DIS45_makehist, DIS45_malloc
      Real  Hie
C begin      
      If( DIS45_needhist(1,error).le.0 ) Return
      Call DIS45_thishist(here,id,dim)
C
      If( DIS45_makehist(id,1,idnew,error).lt.0 ) Return
C
      Call DIS45_hinfo1(id,title,nx,xmin,xmax)
      Call Hcopy(id,idnew,'RER '//title)
C
      If( DIS45_malloc(nx,idbuf,loc,error).lt.0 ) Return
C
      Do j = 1, nx
	Rmem(loc+j-1) = Hie(idnew,j)
      End Do
      Call Hpake(idnew,Rmem(loc))
C
      Call DIS45_free(idbuf)
      Return
      End
