C+
c File : hluser.f
c Description : Execute user-supplied command
c        Dynamic Link to Shared Object
c
c Author : T.Takahashi
c Date : 17 - June - 1994
C
C Hisotory: 95/01/11 remove trailing blanks (pointed by Y.Ishisaki)
C-
c
      Subroutine HLuser ( Error )
c
      Implicit         None
c Arg
      Integer * 4      Error    ! Output
c Common
      Include 'pawc.inc'
C local
      Integer      Address
      Character * 80   exec_name
      Integer * 4  len
C
c Function
c
      Integer  DIS45_dynopen, DIS45_dynlink, DIS45_hasbar
      Integer  Lenrd
C
C data
      Data  exec_name / 'user_command' /
c
c Main
c
c
c 1. Obtain Address of User-supplied Function
c
      If( DIS45_dynopen( 'user function file',exec_name )
     &    .eq.0 ) Then
         len = Lenrd(exec_name)
         Write(*,*) 'exec_name=',exec_name(:len)
         error = 9 ! can't open file
         Return
      End If  
CC    Write(*,*) 'exec_name=',exec_name
C
      address = DIS45_dynlink ( exec_name, 'USER_COMMAND' )
      If( address .eq. 0 ) Then
        error = 28 ! can't load dynamic link module
        Return
      End If
      Call HLuser_call
     &         ( %VAL(Address), error)
C
C 5. Unlink dynamic load module
C
      Call DIS45_dynclose( address )
C
      Return
      End
C
C
      Subroutine HLuser_call( Func, error)
c
      Implicit         NONE
c
c Input
      External  Func
c Output
      Integer * 4  error
c begin
      Call Func ( error )
C
      Return
      End

