C+
c File : hluser.f
c Description : Execute user-supplied command
c        Dynamic Link to Shared Object
c
c Author : T.Takahashi
c Date : 17 - June - 1994
c Date : 15 - Sep - 1994 :  support file:command
C-
c
      Subroutine HLuser ( Error )
c
      Implicit         None
c Arg
      Integer * 4      Error    ! Output
c Common
      Include 'pawc.inc'
      Integer      Address

c
c Function
c
      Integer  DIS45_dynopen, DIS45_dynlink, DIS45_hasbar
      Integer  Lenrd
C
C data
      Character * 80   exec_name
      Data  exec_name / 'user_command' /
      Character * 80   command_name
      Character * 80   name
      Integer lname,pos
c
c Main
c
c
c 1. Obtain Address of User-supplied Function
c
      Call TXTRD('user function (file or file:name)',name)
      lname = Lenrd(name)
      pos = index(name,':')
      If (pos.eq.0) then ! same as the 1st version
       Call Ugetrd(name,lname)
       command_name = 'USER_COMMAND'
      else
        exec_name = name(:pos-1)
        command_name = 'USER_'//name(pos+1:lname)
        Call ugetrd(exec_name,Lenrd(exec_name))
      Endif
      If( DIS45_dynopen( 'user function file',exec_name )
     &    .eq.0 ) Then
         error = 9 ! can't open file
         Return
      End If 

C
      address = DIS45_dynlink ( exec_name, command_name )
      If( address .eq. 0 ) Then
        error = 28 ! can't load dynamic link module
        Return
      End If
      Call HLuser_call
     &         ( %VAL(Address), error)
C
C 5. Unlink dynamic load module
C
      Call DIS45_dynclose( address )
C
      Return
      End
C
C
      Subroutine HLuser_call( Func, error)
c
      Implicit         NONE
c
c Input
      External  Func
c Output
      Integer * 4  error
c begin
      Call Func ( error )
C
      Return
      End



