C
C File: HLwindow.f
C Author: A.Shirahashi
C Date: 4-Jan-1994
C
C History: 10-Feb-1994:add HLw
C
      Subroutine HLw(error)
C
      Implicit None
C output
      Integer error
C local
      Integer nx, ny
C begin
      Call Intrd('Nx',nx)
      Call Intrd('Ny',ny)
      Call HPLzon(nx,ny,1,' ')
      Return
      End
C
C
      Subroutine HLwindow(error)
C
C     Implicit None
C common
      COMMON/HPL1/IPLTNO,IPLNUM,IVSIZE,ICMDUM,IOP   ,IPGSIZ
     +    ,ILTYP ,IGTYP ,IDATE ,IFILE ,ISTAT ,IFIT
     +    ,IHTYP ,IBTYP ,IPTYP ,IFTYP
     +    ,RBCOL ,IBCOL ,IBBCOL,ISBCOL,ISSCOL
     +    ,RHCOL ,IHCOL ,IHBCOL,IHLIST
     +    ,IFCOL ,IFBCOL,IXCOL ,IYCOL
     +    ,IPCOL ,IPBCOL
     +    ,IHWID ,IBWID ,IPWID ,IFWID ,IXWID ,IYWID
     +    ,CPASS ,CSHIFT,DLEN  ,ROFFS ,RWDTH ,ILTSAM,RERRX
     +    ,IDEF1D,IDEF2D
     +    ,LOSAME,LOSLIC,LOWIND,LOGXFL,LOGYFL,LOGZFL,LOZERO,LOCM
     +    ,LOVERT,LOEAH ,LOCHA ,LOASTK,LOSOFT,LOSQR ,LOUTIT,LOTAB
     +    ,LOBOX ,LOTIC ,LOSTAT,LOFIT ,LOZFL ,LOPTO ,LOBAR ,LODVXI
     +    ,LODVYI,LOGRID,LODATE,LOFILE,LWSAME,LTYPFL,LOMAX ,LOZOOM
     +    ,LOZFL1,LOHBOX,LOGTIT
      LOGICAL
     +     LOSAME,LOSLIC,LOWIND,LOGXFL,LOGYFL,LOGZFL,LOZERO,LOCM
     +    ,LOVERT,LOEAH ,LOCHA ,LOASTK,LOSOFT,LOSQR ,LOUTIT,LOTAB
     +    ,LOBOX ,LOTIC ,LOSTAT,LOFIT ,LOZFL ,LOPTO ,LOBAR ,LODVXI
     +    ,LODVYI,LOGRID,LODATE,LOFILE,LWSAME,LTYPFL,LOMAX ,LOZOOM
     +    ,LOZFL1,LOHBOX,LOGTIT
C
      COMMON/HPL2/XLOW  ,XHIGH ,YLOW  ,YHIGH ,XFRAC ,YFRAC ,YMMAX
     +    ,YMMIN ,IOFSET,XWDIST,YWDIST,XWIND ,YWIND ,SCMAX ,IXWIN
     +    ,IYWIN ,IWIN  ,ISLIC
     +    ,NCX
     +    ,IWIN0 ,NTWIN ,NTHIST ,NCHIST
C
C output
      Integer  error
C local
      Real  xmgl,xmgr, ymgl, ymgu, xsiz, ysiz
      Real  xmin, xmax, ymin, ymax
C begin
      Call HPLset('?XMGL',xmgl)
      Call HPLset('?XMGR',xmgr)
      Call HPLset('?YMGL',ymgl)
      Call HPLset('?YMGU',ymgu)
      Call HPLset('?XSIZ',xsiz)
      Call HPLset('?YSIZ',ysiz)
C
      xmin = xmgl
      xmax = xsiz - xmgr
      ymin = ymgl
      ymax = ysiz - ymgu
C
      Call Fltrd('xmin',xmin)
      Call FLtrd('xmax',xmax)
      Call Fltrd('ymin',ymin)
      Call Fltrd('ymax',ymax)
C
C     ... all zero args means reset window mode
      If( xmin.eq.0.0 .and. xmax.eq.0.0 .and.
     &    ymin.eq.0.0 .and. ymax.eq.0.0 ) Goto 100
C
      Call HPLset('XMGL',xmin)
      Call HPLset('XMGR',xsiz-xmax)
      Call HPLset('YMGL',ymin)
      Call HPLset('YMGU',ysiz-ymax)
C
      Call HPLzon(1,1,1,' ')
C     ... here is a trick
      NCHIST = NCHIST + 1
      IWIN = 0
      IWIN0 = 100
      LOWIND = .TRUE.
C
      Return
C
C     ... reset window mode and prepare for a new picture
  100 Continue
      Call HPLset('XMGL',2.0)
      Call HPLset('XMGR',2.0)
      Call HPLset('YMGL',2.0)
      Call HPLset('YMGU',2.0)
      Call HPLzon(1,1,1,' ')
      Call HPLnew
      Return
C
      End
