c+
c File : bin_funct2.f
c Description : sample function for BINOPER command (2dim)
c
c Author : Ryosuke Itoh, Physics Division, KEK and A.Shirahashi
c Date : 8-Feb-1994
c-
c
      Subroutine bin_funct2( ix, iy, x, y, xwid, ywid, z )
c
      Implicit         NONE
c
c input
      Integer * 4      ix      ! X bin Number 
      Integer * 4      iy      ! Y bin Number 
      Real * 4         x       ! X value of the center of bin
      Real * 4         y       ! X value of the center of bin
      Real * 4         xwid    ! X bin width
      Real * 4         ywid    ! X bin width
C input/output
      Real * 4         z       ! Bin Content
c begin
      If( z.gt.100.0 ) Then
        z = 10.0
      Else
        z = sqrt(z)
      End If
C
      Return
      End

