      SUBROUTINE USR_FUNCT (init_flag, x, y)
C----------------------------------------------------------------------
C-
C-   Purpose and Methods : Func. for DISPLAY45 PACKFUN
C-
C-   Created   5-JAN-1993   T.Takahashi
C-
C- function:
C-     Calculate   y = k * (x/energy) ** alpha
C-
C----------------------------------------------------------------------
      IMPLICIT NONE
c
c input:
c
      Logical init_flag
      Real*8 x
c output:
      Real*8 y
c
c local:
      Integer NUMVAL
      Parameter (NUMVAL=3)
      Real*8 par(NUMVAL)
      Save   par
      Character*32 name(NUMVAL) /'k','alpha','energy'/
      Character*32 help(NUMVAL) /
     &  'Overall Factor','Index','Normalized Energy' /
c 
c com dialogue

      If (init_flag) then
        Goto 1
      else
        Continue
      Endif
c
c calc func val:
      y = par(1)*(x/par(3))**par(2)

      Return
c
c parameter initialization (see COM manual for MODVAL)
c
    1 Continue
      Call Init_Com_talk('USR')  
c
c ask parameter (double prec. New COM lib)
      par(1)=1.0D-04
      par(2)=-2.2D0
      par(3)=100.0D0
      Call MODVAL('Single Power Law',NUMVAL, name, help,'D',par)
      
C----------------------------------------------------------------------
  999 RETURN
      END
