C
C File: Logrd.for
C Description: Routines to ask yes or no.
C 
C History: 29-Sep-1994, PROMPT -> CLprom
C
C Public: Logrd, Affirm
C
      Subroutine LOGRD(QUEST,L)
C
      Implicit None 
C ARG
      Logical L
      Character QUEST*(*)
C
C local
      Character M,WORK*80
      Integer  lq
C
C Common
      include 'unitrd.inc'
C
C BEGIN
      LQ = LEN(QUEST)
      WORK = QUEST
C
C..... accept Logical value
C
CCC   Help_save = Help_set
   10 Continue
      If( L ) Then
        M = 'Y'
      Else
        M = 'N'
      End If
C
      Call TXTRD(WORK(1:LQ)//' (Y/N)',M)
CCC   Help_set = Help_save
      Call STRUPC(1,M)
      If (M.eq.'Y' .or. M.eq.'T' .or. M.eq.'1') Then
        L = .TRUE.
      Else If (M.eq.'N' .or. M.eq.'F' .or. M.eq.'0') Then
        L = .FALSE.
      Else
        Call Linrd(1,1)
        Goto 10
      End If
      Return
      End
C
C
      Subroutine AFFIRM( QUEST,L )
C
C .... Show prompt on console and inquire yes/no
C      3-DEC-1986, A.Shirahashi
C
C ARG
      Logical   *  4   L
      Character * (*)  QUEST
C
C COMMON
      include 'tvdisp.inc'
C
C VAR
      Character *  1  M
      Character * 80  WORKS
      Integer   *  4  LQ, IRET
C
C BEGIN
      LQ = LENRD( QUEST )
      WORKS = QUEST
10    Continue
      If( L ) Then
        M = 'Y'
      Else
        M = 'N'
      End If
      If( LTVLOC ) Then
        Call TVPROM( WORKS(1:LQ)//' (Y/N): '//M//' ? ' )
        Call TGET( M,1,'E,W',IRET,LENGTH )
      Else
        Call CLprom( WORKS(1:LQ)//' (Y/N): '//M//' ? ' )
        Read( 5,'(A1)' ) M
      End If
      If( M.eq.' ' ) Then
C       ... return default
      Else
     &If( M.eq.'Y'.or.M.eq.'y'.or.M.eq.'T'.or.M.eq.'t'.or.M.eq.'1')
     &Then
        L = .TRUE.
      Else
     &If( M.eq.'N'.or.M.eq.'n'.or.M.eq.'F'.or.M.eq.'f'.or.M.eq.'0')
     &Then
        L = .FALSE.
      Else
        Goto 10
      End If
C
      Return
      End
