C
C File: HLrethbin.FOR
C Date: 15-Nov-1993
C Author: K.Matsuzaki
C
C History:
C
        Subroutine HLrethbin(error)
C
C change bin size
C
        Implicit None
C common:
	Include 'pawc.inc'
C
C output:
	Integer error
C
C function:
      Integer  DIS45_needhist, DIS45_makehist, DIS45_malloc
      Integer  DIS45_hgetopt
      Real HI, HIE
C local:
      Integer  here, id, dim, idnew
      Integer  idbuf, loc
      Integer  nx, mx
      Integer  I,j
      Real  xmin, xlower, xmax 
      Real bin, sum, sigma, sigma2
      Real thres
      Save thres
      Integer maxfactor
      Save maxfactor
      Character * 80  title
C
C begin
      If (DIS45_needhist(1,error).le.0) Return
      Call DIS45_thishist(here, id, dim)
      Call DIS45_hinfo1(id,title,nx,xmin,xmax)
C
      If( DIS45_hgetopt(id,'BARX').eq.0 ) Return
      If( DIS45_makehist( id,1,idnew,error ).le.0 ) Return
      If( DIS45_malloc( nx*3+1,idbuf,loc,error ).le.0 ) Return
C
      Call Fltrd('Error/Value Thershold',thres) 
      Call Intrd('Maximum-factor',       maxfactor    )
C
      j = 1
      mx = 1
      sum = 0.0
      sigma2 = 0.0
      Call HIX(id,1,xmin)
      Rmem(loc+2*nx) = xmin
      xlower = xmin
      Do i=1,nx
        Call HIX(id,i+1,xmax)
        bin    = xmax - xlower
        xlower = xmax
        sum    = sum    +  HI(id,i) * bin
        sigma2 = sigma2 + (HIE(id,i)* bin) ** 2
        sigma  = sqrt(sigma2)
        If( ( abs(sum).gt. 0.0 .and. abs(sigma/sum) .lt. abs(thres))
     &   .or.  nx.eq.i 
     &   .or. ( maxfactor.ne.0 .and. maxfactor.eq.j) ) Then
          Rmem(loc     +mx-1) = sum   / (xmax-xmin)
          Rmem(loc  +nx+mx-1) = sigma / (xmax-xmin)
          Rmem(loc+2*nx+mx  ) = xmax
          mx = mx+1
          xmin = xmax
          sum = 0.0
          sigma2 = 0.0
          j = 1
        Else
          j = j+1
        Endif
      Enddo
      mx = mx-1
C
      Call HbookB( idnew,'RETHBIN '//title,mx,Rmem(loc+2*nx),0.0 )
      Call Hpak  ( idnew,Hmem(loc) )
      Call Hpake ( idnew,Hmem(loc+nx) )
C  
      Call DIS45_free( idbuf )
C
      Return
      End
C
C     
