C----------------------------------------------------------------------
C-
C-   Purpose and Methods : Condition Handler (AXP version)
C-
C-   Created   8-JUL-1992  T.Takahashi
C-            19-Oct-1992  A.Shirahashi, PutMsg, UnWind(depth)
C-            16-Mar-1993  dis45_establish.for -> dis45_handler_axp.for
C-
C----------------------------------------------------------------------
C
      Integer*4 Function DIS45_HANDLER(SIGARGS, MECHARGS)
      Entry DIS45_HANDLER_AXP(SIGARGS, MECHARGS)
c
      Implicit NONE
c
      Include '($SSDEF)'
      Include '($MTHDEF)'
      Integer  DIS45_HANDLER_AXP
      Integer  LIB$MATCH_COND
      Integer*4 SIGARGS(*), MECHARGS(*)
C local
C      Integer*2 msglen
C      Character*256 errmsg
c
c begin
      Dis45_handler = SS$_RESIGNAL
c
      Write(*,*) SIGARGS(2)
      If(LIB$MATCH_COND(SIGARGS(2),
     &  SS$_FLTOVF,SS$_FLTOVF_F,SS$_FLTDIV,SS$_FLTDIV_F,
     &  SS$_HPARITH).ne.0) Then
        Write(*,*) 
        Call SYS$PUTMSG(sigargs)
        Write(*,*)
        Goto 1000
      End If
C
      If(LIB$MATCH_COND(SIGARGS(2),MTH$_FLOOVEMAT)) Then
        Write(*,*)
        Write(*,*) 
     &    '%MTH-F-FLOOVEMAT, floating overflow in math library'      
        Write(*,*)
        Goto 1000
      End If
C
      If(LIB$MATCH_COND(SIGARGS(2),MTH$_INVARGMAT)) Then
        Write(*,*)
        Write(*,*) 
     &    '%MTH-F-INVARGMAT, invalid argument to math library'      
        Write(*,*)
        Goto 1000
      End If
C
      If(LIB$MATCH_COND(SIGARGS(2),MTH$_SQUROONEG)) Then
        Write(*,*)
        Write(*,*) 
     &    '%MTH-F-SQUROONEG, square root of negative value'
        Write(*,*)
        Goto 1000
      End If
C
      If(LIB$MATCH_COND(SIGARGS(2),MTH$_LOGZERNEG)) Then
        Write(*,*)
        Write(*,*) 
     &    '%MTH-F-LOGZERNEG, logarithm of zero or negative value'
        Write(*,*)
        Goto 1000
      End If
C
      Return
C
 1000 MECHARGS(4) = .false.
      Call SYS$UNWIND(,)
      Return
C
      End
