      SUBROUTINE DIS45_MIN_ERROR_PRINT(error_flag)
C----------------------------------------------------------------------
C-
C-   Purpose and Methods : Print out error 
C-
C-   Created  17-SEP-1992   T.Takahashi
C-
C----------------------------------------------------------------------
      IMPLICIT NONE
c 
c output:
      Integer error_flag
c
      Character*10 chnam
      Real*8 stval,step,bnd1,bnd2
      Real*8  eplus,eminus,eparab
      Real*8 globcc
      Integer IErflag
      Integer number_of_parameters 
      Integer i
c
c COM dialogue
      Integer MAXPARAM
      Parameter (MAXPARAM=50)

      Real    val (MAXPARAM)
      Real    err (MAXPARAM)
      Real    low_limit (MAXPARAM), up_limit (MAXPARAM)
      Real    err_low(MAXPARAM), err_high(MAXPARAM),err_para(MAXPARAM)
      Character*32 help(MAXPARAM)
      Character*32 name(MAXPARAM)
C begin
      Write(*,*) 'Parameter List by MINOS'
      Call DIS45_MIN_get_nparam(number_of_parameters)

      If (number_of_parameters.eq.0) then
        Write(*,*) 'Parameters not yet defined'
        Return
      else if (number_of_parameters.gt.MAXPARAM) then
        Write(*,*) 'WARNING: Number of params exceed MAXPARAM'
      Endif
c
c set value
c      
      Write(6,'(X,A10,X,4A15)') 'NAME','VALUE','PARABOLIC',
     &  'NEGATIVE','POSITIVE'
      DO i=1,number_of_parameters
        Call MNPOUT(i,chnam,stval,step,bnd1,bnd2,ierflag)
        Call MNERRS(i,eplus,eminus,eparab,globcc)
        Write(6,'(X,A10,X,4G15.7)') chnam,stval,eparab,eminus,eplus
      End do

C----------------------------------------------------------------------
  999 RETURN
      END
