
      SUBROUTINE DIS45_MIN_PUNCH(minfile,error_flag)
C----------------------------------------------------------------------
C-
C-   Purpose and Methods : Read Initial values of parameters used in the fit
C-
C-
C-   Created  18-MAY-1992   T.Takahashi
C-
C----------------------------------------------------------------------
      IMPLICIT NONE
c input:
      Character*(*) minfile
c output
      Integer error_flag
C----------------------------------------------------------------------
      Character*10 chnam
      Character*80 title
      Real*8 stval,step,bnd1,bnd2
      Integer Ivarbl
      Integer number_of_parameters 
      Integer i
      Integer lunout

      Call DIS45_MIN_get_nparam(number_of_parameters)

      If (number_of_parameters.eq.0) then
        Write(*,*) 'Parameters not yet defined'
        Return
      Endif
      Call DIS45_MIN_get_title (title)
c
      Call Txtrd('Output file name',minfile)
C      Call LIB$get_lun (lunout)
      Call DIS45_GETLUN (lunout)
#ifndef linux
      Open (Unit=lunout,name=minfile,type='NEW',
     &     CarriageControl='LIST',Err=998)
#else
      Open (Unit=lunout,name=minfile,type='NEW',
     &     Err=998)
#endif
c
      Write(lunout,'(A)') title
      DO i=1,number_of_parameters
        Call MNPOUT(i,chnam,stval,step,bnd1,bnd2,ivarbl)
        If (ivarbl.ge.1) then
          Write (lunout,1001) I,Chnam,stval,step,bnd1,bnd2
 1001     Format (1X,I5,1X,A10,1X,4G13.5)
        else if (ivarbl.lt.0) then ! no definition
          Continue
        else if (ivarbl.eq.0) then ! constant
          Write (lunout,1001) I,Chnam,stval,step
        Endif
      End do
      Write(lunout,*)
      Close(Unit=lunout)
C      Call LIB$free_lun (lunout)
      Call DIS45_freelun (lunout)
      Return
  998 Continue
      error_flag =25
      END
