       SUBROUTINE DIS45_MIN_SETerror
C----------------------------------------------------------------------
C-
C-   Purpose and Methods : Change Current Contents in the variable
C-
C-
C-   Created  18-MAY-1992   T.Takahashi
C-
C----------------------------------------------------------------------
      IMPLICIT NONE
C----------------------------------------------------------------------
      Character*10 chnam
      Real*8 stval,step,bnd1,bnd2
      Integer IErflag
      Integer number_of_parameters 
      Integer i
c
c COM dialogue
      Integer MAXPARAM
      Parameter (MAXPARAM=50)

      Real    val (MAXPARAM)
      Real    err (MAXPARAM)
      Real    low_limit (MAXPARAM), up_limit (MAXPARAM)
      Character*32 help(MAXPARAM)
      Character*32 name(MAXPARAM)
      Call DIS45_MIN_get_nparam(number_of_parameters)

      If (number_of_parameters.eq.0) then
        Write(*,*) 'Parameters not yet defined'
        Return
      else if (number_of_parameters.gt.MAXPARAM) then
        Write(*,*) 'WARNING: Number of params exceed MAXPARAM'
      Endif
c
c set value
c      
      DO i=1,number_of_parameters
        Call MNPOUT(i,chnam,stval,step,bnd1,bnd2,ierflag)
        name(i) = chnam
        help(i) = chnam
        val(i)  = Real(stval)
        err(i)  = Real(step)
        low_limit(i) = Real(bnd1)
        up_limit(i)  = Real(bnd2)
      End do
      Call MODVAL('Error Value',number_of_parameters,name,help,
     &  'R',err)
      DO i=1,number_of_parameters
        Call MNPOUT(i,chnam,stval,step,bnd1,bnd2,ierflag)
        chnam = name(i) 
        stval = Dble(val(i))
        step = Dble(err(i))
        bnd1 = Dble(low_limit(i))
        bnd2 = Dble(up_limit(i))
        Call MNPARM(i,chnam,stval,step,bnd1,bnd2,ierflag)
      End do

      Return
      END
