      SUBROUTINE DIS45_MIN_SETparam_one
C----------------------------------------------------------------------
C-
C-   Purpose and Methods : Change Current Contents in the variable
C-
C-
C-   Created  18-MAY-1992   T.Takahashi
C-
C----------------------------------------------------------------------
      IMPLICIT NONE
C----------------------------------------------------------------------
      Character*10 chnam
      Real*8 stval,step,bnd1,bnd2
      Real*4 stval4,step4,bnd1_4,bnd2_4
      Integer IErflag
      Integer number_of_parameters 
      Integer i
      Integer param_id
c
c COM dialogue
      Integer MAXPARAM
      Parameter (MAXPARAM=50)

      Real    val (MAXPARAM)
      Real    err (MAXPARAM)
      Real    low_limit (MAXPARAM), up_limit (MAXPARAM)
      Character*32 help(MAXPARAM)
      Character*32 name(MAXPARAM)
      Character*10 cmd

C begin
      Call DIS45_MIN_get_nparam(number_of_parameters)

      If (number_of_parameters.eq.0) then
        Write(*,*) 'Parameters not yet defined'
        Return
      else if (number_of_parameters.gt.MAXPARAM) then
        Write(*,*) 'WARNING: Number of params exceed MAXPARAM'
      Endif
c
c set value
c      
      DO i=1,number_of_parameters
        Call MNPOUT(i,chnam,stval,step,bnd1,bnd2,ierflag)
        name(i) = chnam
        help(i) = chnam
        val(i)  = Real(stval)
        err(i)  = Real(step)
        low_limit(i) = Real(bnd1)
        up_limit(i)  = Real(bnd2)
      End do

      Cmd=' '
      Call Keyrd(-1,'?Parameter Name:',Cmd,
     &          name,number_of_parameters,param_id)

      chnam=name(param_id)
      stval4  = val(param_id)
      step4 = err(param_id) 
      bnd1_4 = low_limit(param_id)
      bnd2_4 = up_limit(param_id)
      Call FLTRD('Value',stval4)
      Call FLTRD('Error',step4)
      Call FLTRD('Low_limit',bnd1_4)
      Call FLTRD('Up_limit',bnd2_4)
      Call MNPARM(param_id,chnam,DBLE(stval4),DBLE(step4),
     &  DBLE(bnd1_4),DBLE(bnd2_4),ierflag)

      Return
      END
