      SUBROUTINE DIS45_MIN_SHOW(DIS45_MIN_FCN,error_flag)
C----------------------------------------------------------------------
C-
C-   Created   3-JUN-1992   T.Takahashi
C-
C----------------------------------------------------------------------

      IMPLICIT NONE
c functions:
      External DIS45_MIN_FCN
c output:
      Integer error_flag
c
      Integer igo
      Integer Ncomm
      Parameter (Ncomm = 7)
      Character*5 Comm(Ncomm)
      Data Comm /
     &  'COR  ',
     &  'COV  ',
     &  'EIG  ',          
     &  'EXIT ',          
     &  'FCN  ',
     &  'LIMIT',
     &  'PARAM'
     &  /
c interface to MINUIT
      Real*8 Arglist(10)
      Integer IERRFLAG
c Local:
      Character*5 Cmd
      Character*10 Prompt /'?MIN:SHOW> '/
c
c
c Main Body
c
100   Continue
      Call Keyrd(-1,Prompt,Cmd,Comm,Ncomm,Igo)
      error_flag = 0
      If (Cmd.eq.     'COR  ') then
        Call MNEXCM(DIS45_MIN_FCN, 'SHOW CORRELATIONS',arglist,
     &    0,IERRFLAG)
      else if (Cmd.eq.'COV  ') then
        Call MNEXCM(DIS45_MIN_FCN, 'SHOW COVARIANCE',arglist,0,IERRFLAG)
      else if (Cmd.eq.'EIG  ') then
        Call MNEXCM(DIS45_MIN_FCN, 'SHOW EIGENVALUES',arglist,
     &    0,IERRFLAG)
      else if (Cmd.eq.'FCN  ') then
        Call MNEXCM(DIS45_MIN_FCN, 'SHOW FCNVALUE',arglist,0,IERRFLAG)
      else if (Cmd.eq.'LIMIT') then
        Call MNEXCM(DIS45_MIN_FCN, 'SHOW LIMIT',arglist,0,IERRFLAG)
      else if (Cmd.eq.'PARAM') then
        Call MNEXCM(DIS45_MIN_FCN, 'SHOW PARAMETER',arglist,0,IERRFLAG)
      else if (Cmd.eq.'EXIT ') then
        Goto 999
      Endif
C----------------------------------------------------------------------
  999 RETURN
      END
