C
C Subroutine to calculate theory or model
C 
C
      Subroutine min_funct(x,xwidth,yval,yerr,par,ichoice,all,bak,sig)
C----------------------------------------------------------------------
C-
C-   Purpose and Methods : Function to be used in DISPLAY-MINUIT
C-
C-    Single Power Law
C-
C-_           a*x**b
C-
C-   Created  24-JAN-1991   T.Takahashi
C-
C----------------------------------------------------------------------
      Implicit None
!
!
! input:
      Real*8       x
      Real*8       xwidth             ! Bin width
      Real*8       yval               ! y observation
      Real*8       yerr               ! y error
      Real*8       par(*)            
      Integer      ichoice
C
C output:
      Real*8       all
      Real*8       bak
      Real*8       sig
C
c local:
      Real*8       a,b,Energy
c

      a = par(1)
      b = par(2)
      Energy = par(3)

      sig = a*(x/Energy)**b
      bak = 0
      all = sig+bak
c
      Return
      End
