C
C File: HLaxtitl.for
C Description: Define titles along the X/Y axes.
C Author: A.Shirahashi
C Date: 3-AUG-1992
C
C History: 5-Aug-1992, axtit, aytit
C          10-Aug-1992, error check
C          18-Sep-1992, dis45_set/getopt(id,...)
C          7-Jun-1993, ytitle (by R.Itoh)
C
C Public: HLaxtitl, HLaxis_title
C
      Subroutine HLaxtitl(error)
C
      Implicit None 
C output
      Integer  error
C local
      Character * 80  xtitle, ytitle         
      Integer  axtype
C local (HLaxis_title)
      Logical  flag
      Integer  here, id, dim, nent, junk
      Character * 32  axtitl
C function
      Integer  DIS45_needhist, Lkbrd
C data
      Save  xtitle, ytitle, axtype
      Data  xtitle / 'x axis' /
      Data  ytitle / 'y axis' /
      Data  axtype / 2 /
C begin
      Call Intrd('0:none 1:ID 2:ID,N 3:user',axtype)
C
      If( axtype.eq.3 ) Then
        If( DIS45_needhist(0,error).le.0 ) Return
        Call DIS45_thishist(here,id,dim)
        Call Titrd('X title',xtitle)
        Call Titrd('Y title',ytitle)
        Call DIS45_setopt(id,'PLAX')
      End If
C
      Return
C
C
      Entry HLaxis_title
C
      Call DIS45_thishist(here, id, dim)
      Call DIS45_getopt(id,'PLAX',flag)
C
      If( flag ) Then
        Call Hplax(xtitle,ytitle)
      Else If( axtype.gt.0 ) Then
        Call Hnoent(id, nent)
        If( axtype.eq.1 ) Then
          Write(axtitl,1000) id
 1000     Format('ID=',I10)
        Else If( axtype.eq.2 ) Then
          Write(axtitl,1010) id, nent
 1010     Format('ID=',I10,',N=',I10)
        Else
          Write(*,*) 'HLaxis_title: unknown type: ', axtype
        End If
        junk = Lkbrd(axtitl,0)
        Call Hplax(axtitl,' ')
      End If
C
      Return
      End
