C
C File: HLchtit.for
C Description: Change title of histogram
C Author: A.Shirahashi
C Date: 2-JUN-1992
C
C History: 3-Aug-1992, HLgtit
C          30-Aug-1993, for N-tuple (slow for large tuples)
C
C Public: HLchtit, HLgtit
C
      Subroutine HLchtit(error)
C
      Implicit None
C output
      Integer  error
C local
      Integer  here, id, dim, idnew
      Character * 80  title
C function
      Integer DIS45_needhist, DIS45_makehist
C begin
      If( DIS45_needhist(0,error).le.0 ) Return
      Call DIS45_thishist(here, id, dim)

C     
      Call Titrd('?title',title)
C
C     ... this implementation is ugly, but it works.
      If( DIS45_makehist(id, dim, idnew, error).le.0 ) Return
      If( dim.eq.1 .or. dim.eq.2 ) Then
        Call Hcopy(id,idnew,title)
        Call Hdelet(id)
        Call Hcopy(idnew,id,title)
      Else If( dim.eq.3 ) Then
        Call Dis45_CopyNt(id,idnew,title)
        Call Hdelet(id)
        Call Dis45_CopyNt(idnew,id,title)
      End If
      Call DIS45_hdelete(idnew)
      Return
      End
C
C
      Subroutine HLgtit(error)
C
      Implicit None 
C output
      Integer  error
C local
      Integer  here, id, dim
      Character * 80  title
      Save  title
      Data  title / 'Display Histogram' /
C function
      Integer DIS45_needhist
C begin
      If( DIS45_needhist(0,error).ge.0 ) Then
        Call DIS45_thishist(here, id, dim)
        Call DIS45_hinfo0(id,title,dim)
      End If
      Call Titrd('global title',title)
      Call Htitle(title)
      Return
      End
C
