C
C File: HLcopy.for
C Author: T.Takahashi
C
C History: 26-Jun-1992, A.Shirahashi, DIS45_numhist
C           3-Jul-1992, A.Shirahashi, bug fix, DIS45_makehist
C           6-Aug-1992, A.Shirahashi, add HLdupl
C          22-Sep-1992,               N-tuples
C
C Public: HLcopy, HLdupl
C
      Subroutine HLcopy(error)
      Implicit NONE
c output
      Integer error
c local:
      Character*80 title
      Integer id,dim,idnew
      Integer here
c function
      Integer DIS45_needhist, DIS45_makehist
C begin
      If (DIS45_needhist(0,error).le.0) Return
      Call DIS45_thishist(here, id, dim)
      Call DIS45_hinfo0(id,title,dim)
C
      If( DIS45_makehist(id,dim,idnew,error).le.0 ) Return
      Call Titrd('title', title)
C
      If( dim.eq.1 .or. dim.eq.2 ) Then
        Call Hcopy(id,idnew,title)
      Else If( dim.eq.3 ) Then
        Call DIS45_CopyNT(id,idnew,title)
      Else
        Print *, 'HLcopy: unknown dim = ', dim
      End If
C
      Return
      End
C
C
      Subroutine HLdupl(error)
      Implicit NONE
c output
      Integer error
c local
      Character*80 title
      Integer id,dim,idnew
      Integer here
c function
      Integer DIS45_needhist
      Logical Hexist
C begin
      If (DIS45_needhist(0,error).le.0) Return
      Call DIS45_thishist(here, id, dim)
      Call DIS45_hinfo0(id,title,dim)
C
      Call DIS45_findID(idnew,id)
      Call Intrd('to ID',idnew)
      If( idnew.le.0 ) Return
      If( Hexist(idnew) ) Then
        error = 16 ! histogram already exist
        Return
      End If
      Call DIS45_insert(idnew,dim,error)
C
      If( dim.eq.1 .or. dim.eq.2 ) Then
        Call Hcopy(id,idnew,title)
      Else If( dim.eq.3 ) Then
        Call DIS45_CopyNT(id,idnew,title)
      Else
        Print *, 'HLdupl: unknown dim = ', dim
      End If
C
      Return
      End
