c+
c File : hldevi.f
c Description : Select Graphic Device
c
c Author : Ryosuke Itoh, TOPAZ, KEK
c Date : 7 - JAN - 1991
c
c History: 24-Jun-1992, A.Shirahashi, use direct calls to GKS routines
c                                     in stead of IGMETA
c                       A.Shirahashi, ask ON/OFF here
C          29-Jun-1992, A.Shirahashi, status -> status, gkstat
C          14-Jul-1992, A.Shirahashi, ask filename
C          05-Aug-1992, T.Takahashi,  support CLOSE 
C          21-Aug-1992, A.Shirahashi, deactivate and close workstation
C                                     when CLOSE requested
C           4-Jan-1993, add EPS, 2x1, 2x2 options
C          12-Feb-1993, add landscape, 3x2, 3x3 options
c-
c
      Subroutine HLDEVI ( error )
c
      Implicit         NONE
c
c Arg
      Integer * 4  error
c
c Cons
      Integer * 4      IDMETA, LUNPS, TYPEPS
      Parameter        ( IDMETA = 11, LUNPS = 10, TYPEPS = -111 )
c
c Var
c
      Character * 5  ans
      Integer  switch, Lpost
      Logical  Status
      Real  gkstat
C
      Integer  Cur_Sw, pstype
      Character * 80  postfile
      Save Cur_Sw, postfile
c function
      Integer  Lenrd
      Logical  Qopen
C data
      Data Cur_Sw / 0 /
      Data postfile / 'display.ps' /
c
c Main
      pstype = -111
C
  100 Continue
C
C     ... ask ON/OFF
      If( cur_sw .ne.0 ) Then
        ans = 'OFF'
      Else
        ans = 'ON'
      End If
C
      Call Txtrd('on/off/close',ans)
      Call Strupc(5,ans)
C
      If( ans.eq.'ON   ' ) Then
        switch = 1
      Else If( ans.eq.'OFF  ' ) Then
        switch = 0
      Else If( ans.eq.'CLOSE') Then
        switch = -1
      Else If( ans.eq.'EPS  ') Then
        pstype = -113
        Goto 100
      Else If( ans.eq.'2X1  ') Then
        pstype = -212
        Goto 100
      Else If( ans.eq.'2X2  ') Then
        pstype = -221
        Goto 100
      Else If( ans.eq.'3X2  ') Then
        pstype = -322
        Goto 100
      Else If( ans.eq.'3X3  ') Then
        pstype = -331
        Goto 100
      Else If( ans.eq.'LANDS') Then
        pstype = -112
        Goto 100
      Else
        error = 23 ! illegal option
        Return
      End If
C
      If ( Cur_Sw .EQ. Switch ) Return
      Cur_Sw = Switch
c
      If ( Cur_Sw .EQ. 1 ) then
        Inquire ( Unit=LUNPS, Opened=Status )
        If ( .not. Status ) then
C         Open ( Unit=LUNPS, File='display.ps', Form='Formatted', 
C     #          Status='New',CARRIAGECONTROL='LIST' )
          Status = Qopen('postscript file:',LUNPS,postfile,
     &                   'WRITE','LIST','NEW')
          If( .not. Status ) Then
            error = 9 ! can't open file
            Return
          End If
        End If
        Call IGZSET ( 'G' )
C
C       Call HPLCAP ( LUNPS )
C       Call IGMETA(LUNPS, 111)
C
        Call IGQWK(IDMETA,'OPEN',gkstat)
        If( gkstat.eq.0.0 ) Then
          Call IOPWK(IDMETA,LUNPS,pstype)
        End If
C
        Call IGQWK(IDMETA,'ACTI',gkstat)
        If( gkstat.eq.0.0 ) Then
          Call IACWK(IDMETA)
        End If
C
      Else If ( Cur_Sw .EQ. 0 ) then
C
C       Call HPLNUL
C       Call HPLCAP ( 0 )
C
        Call IGQWK(IDMETA,'ACTI',gkstat)
        If( gkstat.ne.0.0 ) Then
          Call IDAWK(IDMETA)
        End If
C
      Else If ( Cur_Sw .EQ. -1 ) then
        Inquire ( Unit=LUNPS, Opened=Status )
        If ( .not. Status ) then
          Return  ! Not yet Opened, Command Ignored
        else
          Call IGQWK(IDMETA,'ACTI',gkstat)
          If( gkstat.ne.0.0 ) Then
            Call IDAWK(IDMETA)
          End If
          Call IGQWK(IDMETA,'OPEN',gkstat)
          If( gkstat.ne.0.0 ) Then
            Call ICLWK(IDMETA)
          End If
          Close(unit=LUNPS)
          Lpost = Lenrd(postfile)
          Write(6,*) 'File ',postfile(:Lpost),' closed ...'
        Endif
      End If
      Return
      End
      



