C
C HLerro.for
C Entry: HLerro, HLreer, HLnoer
C Date: 21-Apr-1992
C Author: A.Shirahashi
C 
C History: 20-Jul-1992, A.Shirahashi, remove 'RER' (to HLrerro.for)
C
      Subroutine HLerro(error)
C 
      Implicit None
C output
      Integer  error
C local
      Integer  here, id, dim
C function
      Integer  DIS45_needhist
C begin
      If( DIS45_needhist(0,error).le.0 ) Return
      Call DIS45_current_his(here,id,dim)

      Call DIS45_hsetopt(id,'PERR') ! print error
C
      Return
      End
C
C
      Subroutine HLnoer(error)
C 
      Implicit None
C output
      Integer  error
C local
      Integer  here, id, dim
C function
      Integer  DIS45_needhist, DIS45_hgetopt
C begin
      If( DIS45_needhist(0,error).le.0 ) Return
      Call DIS45_current_his(here,id,dim)

      If( DIS45_hgetopt(id,'PERR').eq.0 .and.
     &    DIS45_hgetopt(id,'ERRO').eq.0 ) Then
C       NBAX option necessary to clear PAKE error
        Call DIS45_hsetopt(id,'NBAX') ! NO BARX
      Else
        Call DIS45_hsetopt(id,'NPER') ! inverse of ER
        Call DIS45_hsetopt(id,'NERR') ! inverse of RER
      End If
C
      Return
      End
