C
C File: HLfetm_unix.f
C Description: Fetch from shared section
C
C History: 15-Jun-1992, A.Shirahashi, use Iopen
C          16-Jun-1992, A.Shirahashi, use Qopen
C          25-Jun-1992, A.Shirahashi, use DIS45_getlun
C           2-Jun-1992, A.Shirahashi, support FZ format file
C           3-Jun-1992, A.Shirahashi, try to fix ERROR, but in vain
C          20-Oct-1992, A.Shirahashi, HLfetm
C           1-Nov-1992, use Hropen instead of Hrfile
C           8-Dec-1992, add HLfetx
C           9-Dec-1992, bug fix (freelun)
C          28-May-1993, hlfetm separated
C           2-Apr-1994, HLtahi -> DIS45_inchist
C
      Subroutine Hlfetm(error)
      Implicit None
C comon
      Include 'pawc.inc'
c output:
      Integer error
c function:
      Integer Hmapm, Lenrd
c local:
      Character*16 memblk
      Integer Lmem, Istat, Ioffst
      Integer N, Nhists, Ihist
C data
      Data memblk /'MEM'/
C begin
      Call Txtrd('memory block name',memblk)
      Lmem = Lenrd(memblk)
C
      Istat = Hmapm(memblk(:Lmem),Hmem(11),Ioffst)
      If( Ioffst.le.0 ) Goto 999
C
      Call Hrfile(Hmem(Ioffst+11),memblk(:Lmem),'m')
C
      Call Intrd('?how many histograms (0 for all)',Nhists)
      If (Nhists.eq.0) Then
        Call Hrin(0,9999,0)
      Else
        Do N=1,Nhists
    1     Call Intrd('?histogram id#',Ihist)
          If (Ihist.gt.0) Then
            Call Hrin(Ihist,9999,0)
          Else                            
            Goto 1
          End If
        End Do
      End If
201   Continue
C
      Call DIS45_inchist( 'M' )
C
      Return
C
  999 Continue
      error = 9                       ! file not found
      Return
      End
C
C

