C
C File: HLglob.for
C Description: global operation prefix
C Author: A.Shirahashi
C Date: 14-Jul-1992
C
C History: 28-Sep-1992, call display45_command
C          29-Sep-1992, display45_getcomand, display45_docomand
C           5-Oct-1992, dis45_getcomand(mode,...)
C
C Public  HLglob
C
      Subroutine HLglob(error)
C
      Implicit None 
C common
      Include 'pawc.inc'
C output
      Integer  error
C local
      Integer  here, id, idold, dim
      Integer  nhist, nsel, first, last
      Integer  i, length, Lans, Lend, Lpat
      Integer  idbuf, loc
      Character * 80  ans, pat, title, command
C function
      Integer  DIS45_numhist, DIS45_malloc, DIS45_lookup, DIS45_info_i
      Integer  Lenrd
C save
      Save  pat, Lpat
C begin
      nhist = DIS45_numhist(error)
      If( nhist.le.0 ) Return
      Call DIS45_thishist(here,idold,dim)
      If( DIS45_malloc( nhist,idbuf,loc,error ).le.0 ) Return
C
      first = idold
      Call CLitoa(id,ans)
      Call Titrd('first ID (0:all) or /pat/',ans)
      Lans = Lenrd(ans)
      Lpat = 0
C
      If( ans(1:1).eq.'/' ) Then
        Lend = Index(ans(2:),'/')
        If( Lend.eq.1 ) Then
C         ... use previous pattern
        Else If( Lend.gt.1 ) Then
          Lpat = Lend - 1
          pat(:Lpat) = ans(2:Lend)
          Call Ugetrd(ans(Lend+2:),Lans-Lend-1)
        End If
        If( Lpat.le.0 ) Then
          error = 37
          Return
        End If
      Else
        Call Ugetrd(ans,Lans)
        Call Intrd('first ID (0:all)',first)
      End If
C
      If( Lpat.gt.0 ) Then
        nsel = 0
        Do i = 1, nhist
          id = DIS45_info_i(i)
          Call DIS45_hinfo0(id,title,dim)
          If( Index(title,pat(:Lpat)).gt.0 ) THen
            nsel = nsel + 1
            Hmem(loc+nsel) = id
          End If
        End Do
        Goto 100
      Else If( first.eq.0 ) Then
        Do i = 1, nhist
          Hmem(loc+i) = DIS45_info_i(i)
        End Do
        nsel = nhist
        Goto 100
      End If
C
      last = first
      Call Intrd('last ID (0:cancel):',last) 
C
      If( last.le.0 ) Then
        Goto 800
      Else
        nsel = 0
        Do i = first, last
          If( DIS45_lookup(i).gt.0 ) Then
            nsel = nsel + 1
            Hmem(loc+nsel) = i
          End If
        End Do
      End If
C
  100 Continue
      Call Titrd('?command',command)
      length = Lenrd(command)
      If( length.le.0 ) Goto 800
C
C     Do i = nsel, 1, -1
      Do i = 1, nsel
        id = Hmem(loc+i)
C       Write(seth,*) 'h ',id
C       Lset = Lkbrd(seth,1)
C       Call Ugetrd( seth(:Lset)//' '//command,Lset+length+1 )
C       Write(*,*) seth(:Lset)//' '//command(:length)
        Call DIS45_sethist(id,error)
        If( error.ne.0 ) Goto 800
        Call HLglob_execute(command(:length),error)
        If( error.ne.0 ) Then
          Write(*,1000) 'Error occured at ID = ', id
 1000     Format(1H ,A,I5)
          Call Display45_error(error)
          error = 0
          Goto 800
        End If
      End Do
C        
  800 Continue
      Call DIS45_sethist(idold,error)
      Call DIS45_free(idbuf)
      Return
      End
C
C
      Subroutine HLglob_execute(command,error)
C
      Implicit None
C input
      Character * (*)  command
C output
      Integer error, igo
C local
      Character * 6  cmd
      Integer  length
C begin
      Call Ugetrd(command,Len(command))
 100  Continue
      Call Display45_GetComand(-3,'?DIS>',cmd,igo)
      Call Display45_DoComand(cmd,error)
      If( error.ne.0 ) Return
      Call CLlast( length )
      If( length.gt.0 ) Goto 100
C
      Return
      End

      

