c+
c File : HLhigz.for
c Description : Turn on/off HIGZ metafile output
c
c Author : A.Shirahashi
c Original : HLdevi.for
c Date: 13-Jul-1992
C
C History: 11-Aug-1992, use IZOPEN
C           9-Oct-1992, CLOSE
c-
c
      Subroutine HLhigz ( error )
c
      Implicit         None
c
c Arg
      Integer * 4  error
c
c constant
      Integer * 4      IDMETA, LUNMETA
      Parameter        ( IDMETA = 11, LUNMETA = 11 )
c local
      Character * 5  ans
      Integer * 4  switch, Lmeta, Istat
      Logical * 4  Status, icycle
      Character * 80  metafile
      Integer * 4  Cur_Sw 
c function
      Logical  Qopen
      Integer  Lenrd
c data
      Save metafile, cur_sw
      Data metafile / 'display.higz' /
      Data cur_sw / 0 /
c begin
      If( cur_sw .ne. 0 ) Then
        ans = 'OFF'
      Else
        ans = 'ON'
      End If
      Call Txtrd('on/off/close',ans)
      Call Strupc(5,ans)
      If( ans(1:2).eq.'ON' ) Then
        switch = 1
      Else If( ans(1:2).eq.'OF' ) Then
        switch = 0
      Else If( ans(1:1).eq.'C' ) Then
        switch = -1
      Else
        Return
      End If
C
      If ( Cur_Sw .eq. Switch ) Return
      Cur_Sw = Switch
c
      If ( Cur_Sw .eq. 1 ) Then
        Inquire ( Unit=LUNMETA, Opened=Status )
        If ( .not. Status ) Then
          Status = Qopen( 'HIGZ metafile:',-LUNMETA,metafile,
     &                    'DIRECT=1024','UNFORMATTED','NEW' )
          If( .not. Status ) Then
            error = 9 ! can't open file
            Return
          End If
C*        Call IZFILE( LUNMETA,'HIGZ','NA' )
          Lmeta = Lenrd(metafile)
          Call IZOPEN( LUNMETA,'HIGZ',metafile(:Lmeta),'NA',1024,
     &                 Istat )
          If( Istat.ne.0 ) Then
            error = 9 ! can't open file
            Return
          End If
        End If
        Call HPLOPT('ZFL ',1)
      Else If( Cur_Sw .eq. 0 ) Then
        Call HPLOPT('NZFL',1)
      Else If( Cur_Sw .eq. -1 ) Then
        Call IZOUT(' ',icycle)
        Call RZEND('HIGZ')
        Close(Unit=LUNMETA)
        Call IZPICT('*','S')
        Call HPLOPT('NZFL',1)
      End If
C
      Return
      End
        



