C+
C File : HLexte
C Description : Unpack/pack error into a new histogram
C
C History : 14-Oct-1992, for display45 by A.Shirahashi
C           16-Oct-1992, use Hunpak
C
C Public: HLexte, HLpake
C-
C
      Subroutine HLexte(error)
C
      Implicit None
C common
      Include 'pawc.inc'
C output
      Integer  error
C local
      Character * 80  title
      Integer  here, dim, id, idnew
      Integer  idbuf, loc
      Integer  I, nx
      Real  xmin, xmax
C
C Function
      Real     Hie
      Integer  DIS45_needhist, DIS45_makehist, DIS45_malloc
C
C MAIN
C
      If( DIS45_needhist(1,error).le.0 ) Return
      Call DIS45_thishist(here,id,dim)
C
      Call DIS45_hinfo1(id,title,nx,xmin,xmax)
C
      If( DIS45_malloc(nx,idbuf,loc,error).le.0 ) Return
      If( DIS45_makehist(id,1,idnew,error).le.0 ) Return
C
      Call Hcopy(id,idnew,'EXTE '//title)
      Call Hpake(idnew,Rmem(loc))
C
      Do 10 I = 1, nx
        Rmem(loc+I-1) = Hie(id,I)
10    Continue
C
      Call Hpak( idnew, Rmem(loc) )
      Call DIS45_fixentry(idnew)
      Call DIS45_free( idbuf )
C
      Return
      End
C
C
      Subroutine HLpake(error)
C
      Implicit None
C common
      Include 'pawc.inc'
C output
      Integer  error
C local
      Character * 80  title
      Integer  here, dim, id, iderr, idnew
      Integer  idbuf, loc
      Integer  I, nx
      Real  xmin, xmax
C function
      Real     Hi
      Integer  DIS45_needhist, DIS45_samehist, DIS45_malloc
C
C begin
      If( DIS45_needhist(1,error).le.0 ) Return
      Call DIS45_thishist(here,id,dim)
C
      iderr = id
      Call Intrd('error histogram ID',iderr)
C
      If( DIS45_samehist(id,iderr,error).le.0 ) Return
C
      Call DIS45_hinfo1(id,title,nx,xmin,xmax)
C
      If( DIS45_malloc(nx,idbuf,loc,error).le.0 ) Return
C
      Call Hunpak(iderr,Rmem(loc),'HIST',1)
      Call Hpake( id, Rmem(loc) )
C
      Call DIS45_free( idbuf )
C
      Return
      End
C
