C
C File: HLrandom.for
C Description: Generation of the spectrum
C Date: 22-Dec-1992
C Author: T.Takahashi
C
C Public HLrndm
C
      Subroutine HLrandom( error )
      Implicit None
C output:
      Integer  error
C local:
      Character * 80  title  
      Integer  here, dim, id, idnew
      Integer  nx, i, idbuf, loc
      Real  xmin, xmax, sum
      Integer  nent, region
      Real R
      Integer idjunk, junk
C common:
      Include 'pawc.inc'
C function:
      Integer  DIS45_needhist, DIS45_makehist, DIS45_malloc
      Integer  DIS45_lookup
      Real  Hrndm1
      Real  Hi
C begin:
      If( DIS45_needhist(1,error).le.0 ) Return
      Call DIS45_thishist(here,id,dim)
C
      Call Intrd('Number of entries to generate', nent)
      If (nent.le.0) then
        error=34
        Return
      Endif
C
      Call DIS45_hinfo1(id,title,nx,xmin,xmax)
      If( DIS45_makehist(id,1,idjunk,error).le.0 ) Return
      Call Hcopy(id,idjunk,'JNK '//title)
      If( DIS45_makehist(idjunk,1,idnew,error).le.0 ) Return
      Call Hcopy(id,idnew,'RND '//title)
      If( DIS45_malloc(nx,idbuf,loc,error).le.0 ) Return
C
        Do i = 1, nx
          Rmem(loc+i-1) =  Hi(id,i)
        End Do
        Call Hpak( idjunk, Rmem(loc) )
        Call DIS45_free(idbuf)

C first call is to integrate contents to obtain prob. func
      R = Hrndm1(idjunk)
c
c Fill
      Do i=1,nent
        R = Hrndm1(idjunk)
        Call Hf1(idnew, R, 1.0)
      End do
C
C
      Call DIS45_hsetopt(idnew,'NPFU')
      Call Hminim(idnew,0.0)
      Call Hmaxim(idnew,0.0)
c delete histogram
      junk = DIS45_lookup(idjunk)
      If( junk.gt.0 ) Then
            Call DIS45_delhist(junk)
            Call Hdelet(idjunk)
      End If
C
      Return
      End
