c+
c File : bin_funct.f
c Description : sample function for BINOPER command
c
c Author : Ryosuke Itoh, Physics Division, KEK and A.Shirahashi
c Date : 19 - May - 1993
c-
c
      Subroutine bin_funct( nbin, xbin, xwid, y, dy )
c
      Implicit         NONE
c
c input
      Integer * 4      nbin    ! bin Number
      Real * 4         xbin    ! X value of the center of bin
      Real * 4         xwid    ! X bin width
C input/output
      Real * 4         y       ! Bin Content
      Real * 4         dy      ! Error Content
c begin
      If( y.gt.0.0 ) Then
        dy = dy / (2.0 * sqrt(y))
        y = sqrt(y)
        y = 5.0
      Else
        dy = 0.0
        y = 0.0
      End If
C
      Return
      End

